<?php
/**
 * @version 2.0 2012-01-20
 * @package Joomla
 * @subpackage Intellectual Property
 * @copyright (C) 2012 the StarTech
 * @license GNU/GPL see LICENSE.php
 */

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.view');

class IpropertyViewImport_csv extends JView 
{
    protected $user;
    protected $csvFiles;
    
    public function display($tpl = null)
	{
        $this->user   = JFactory::getUser();
        
        // Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}

        // Check if the user should be in this editing area
        if (!$this->user->authorise('core.admin')){
            $this->setLayout('noaccess');
            $this->_displayNoAccess($tpl);
            return;
        }
        
        $csvFiles       = JFolder::files(JPATH_SITE.DS.'media'.DS.'com_iproperty', '.csv');
		$coptions       = array();
		foreach ($csvFiles as $cfiles):
			$coptions[] = JHTML::_('select.option', $cfiles, $cfiles);
		endforeach;
        
		$this->csvFiles = JHTML::_('select.genericlist', $coptions, 'csv_file', 'size="10" class="inputbox" style="width: 300px;"');		

		$this->addToolbar();
		parent::display($tpl);
	}
    
    protected function addToolbar()
	{
		JToolBarHelper::title('<span class="ip_adminHeader">'.JText::_('COM_IPROPERTY_IMPORT_CSV_FILE').'</span>', 'iproperty');

        // Only show these options to admin
        if ($this->user->authorise('core.admin')){
            JToolBarHelper::custom( 'import_csv.importCSV', 'restore.png', 'restore_f2.png', JText::_( 'COM_IPROPERTY_IMPORT' ), false, false );
            JToolBarHelper::divider();
        }  
        JToolBarHelper::cancel('import_csv.cancel','JTOOLBAR_CANCEL');
	}

	public function _displayNoAccess($tpl = null)
    {
        JToolBarHelper::title( '<span class="ip_adminHeader">'.JText::_( 'COM_IPROPERTY_NO_ACCESS' ).'</span>', 'iproperty' );
        JToolBarHelper::back();
        JToolBarHelper::spacer();
        
        parent::display($tpl);
    }
}
?>