<?php
/**
 * @version 1.7.1 2011-10-27
 * @package Joomla
 * @subpackage Iproperty
 * @copyright (C)  2011 the Thinkery
 * @license see LICENSE.php
 */

defined('_JEXEC') or die('Restricted access');
require_once(JPATH_SITE.DS.'components'.DS.'com_iproperty'.DS.'helpers'.DS.'route.php');
require_once(JPATH_SITE.DS.'components'.DS.'com_iproperty'.DS.'helpers'.DS.'html.helper.php');
require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_iproperty'.DS.'classes'.DS.'admin.class.php');

jimport('joomla.utilities.date');

class modIPOpenhouseHelper
{

    function getList(&$params)
	{
		$db         = JFactory::getDBO();
        $count 		= $params->get('count', 10);
        
		$query = 'SELECT * FROM #__iproperty_openhouses'
                .' WHERE state = 1'
                .' AND openhouse_end >= NOW()'
                .' ORDER BY openhouse_start ASC'
                .' LIMIT '.(int)$count;
        
        $db->setQuery($query);
        $rows = $db->loadObjectList();

        $i		= 0;
        $lists	= array();
        if( $rows ){
            foreach ( $rows as $row )
            {
                $available_cats = ipropertyHTML::getAvailableCats($row->prop_id);
                $first_cat      = $available_cats[0];

                $lists[$i]->name            = $row->name;
                $lists[$i]->link            = JRoute::_(ipropertyHelperRoute::getPropertyRoute($row->prop_id, $first_cat));
                $lists[$i]->street_address  = htmlspecialchars( ipropertyHTML::getPropertyTitle($row->prop_id) );
                $lists[$i]->start           = JFactory::getDate($row->openhouse_start)->format($params->get('date_format', 'l, d F Y g:ia'));
                $lists[$i]->end             = JFactory::getDate($row->openhouse_end)->format($params->get('date_format', 'l, d F Y g:ia'));
                $i++;
            }
        }
        
        return $lists;
	}

}