<?php
/**
 * @version 2.0 2012-01-20
 * @package Joomla
 * @subpackage Intellectual Property
 * @copyright (C) 2012 the StarTech
 * @license GNU/GPL see LICENSE.php
 */

if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) { die( 'Direct Access to this location is not allowed.' ); }
require_once(JPATH_SITE.DS.'components'.DS.'com_iproperty'.DS.'helpers'.DS.'html.helper.php');
require_once(JPATH_SITE.DS.'components'.DS.'com_iproperty'.DS.'helpers'.DS.'property.php');
require_once(JPATH_SITE.DS.'components'.DS.'com_iproperty'.DS.'helpers'.DS.'route.php');
require_once(JPATH_SITE.DS.'components'.DS.'com_iproperty'.DS.'helpers'.DS.'query.php');
require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_iproperty'.DS.'classes'.DS.'admin.class.php');

class IpcblistingsTab extends cbTabHandler
{
	function IpcblistingsTab() {
		$this->cbTabHandler();
	}

    function _getLanguageFile() {
		global $_CB_framework;
		$IplanguagePath = $_CB_framework->getCfg( 'absolute_path' ).'/components/com_comprofiler/plugin/user/plug_cbiplistings';
		if (file_exists($IplanguagePath.'/language/'.$_CB_framework->getCfg('lang').'.php')) {
		  include_once($IplanguagePath.'/language/'.$_CB_framework->getCfg('lang').'.php');
		} else include_once($IplanguagePath.'/language/english.php');
	}
	
	function getDisplayTab($tab,$user,$ui) {
        global $_CB_database, $_CB_framework, $ueConfig;
		$this->_getLanguageFile();
		$return = null;
        $params	=	$this->params;
        $title	=	cbReplaceVars( $params->get( 'title', '_IP_CBLISTINGS_TXT' ), $user );
        $name	=	getNameFormat( $user->name, $user->username, $ueConfig['name_format'] );
        $ipauth = new ipropertyHelperAuth();

        if(!$ipauth->getUagentId()) return false;

        // Valid agent - continue to check if the agent has listings
        $where = array();
        $where[] = 'am.agent_id = '.(int)$ipauth->getUagentId();
        $properties = $this->getPropertiesList($where);

        // Add stylesheet
        $_CB_framework->addCustomHeadTag("<link href=\"".$_CB_framework->getCfg( 'live_site' )."/components/com_iproperty/assets/css/iproperty.css\" rel=\"stylesheet\" type=\"text/css\" />");

        // Begin tab display
        $return = '<table class="ptable">
                    <tr>
                        <td colspan="2">
                            <div class="contentheading" id="cbProfileTitle">' . sprintf( $title, $name ) . '</div>
                            '.$this->_writeTabDescription( $tab, $user ).'
                        </td>
                    </tr>';
                    if(count($properties)){                        
                        $k = 0;
                        foreach($properties as $p){
                            $return .= $this->displayOverview($p, $k);
                            $k = 1 - $k;
                        }
                    }else{
                        $return .= '<tr><td colspan="2" align="center">'._IP_CBLISTINGS_NORESULT.'</td></tr>';
                    }
        $return .= '</table>';

		return $return;
	} // end or getDisplayTab function

    function getPropertiesList( $where, $limitstart=0, $limit=9999, $sort = 'p.title', $order = 'ASC' )
	{
        global $_CB_database;
        
        $property = new ipropertyHelperproperty($_CB_database);
        $property->setType('properties');
        $property->setWhere( $where );
        $property->setOrderBy( $sort, $order );
        $properties = $property->getProperty($limitstart,$limit);
        return $properties;
	}

    function displayOverview($p, $k){
        global $_CB_framework;

        // Define vars to use in display
        $settings           = ipropertyAdmin::config();

        $ipbaseurl          = $_CB_framework->getCfg( 'live_site' );
        $settings           = $settings;
        $accent_color       = ( $settings->accent ) ? $settings->accent : '#d2e4ea';
        $secondary_accent   = ( $settings->secondary_accent ) ? $settings->secondary_accent : '#deeaff';
        $thumb_width        = ( $settings->thumbwidth ) ? $settings->thumbwidth . 'px' : '200px';
        $thumb_height       = round((( $thumb_width ) / 1.5 ), 0) . 'px';
        $folder             = $ipbaseurl.$settings->imgpath;

        $available_cats     = ipropertyHTML::getAvailableCats($p->id);
        $cat_id             = $available_cats[0];
        $plink              = JRoute::_(ipropertyHelperRoute::getPropertyRoute($p->id.':'.$row->prop_alias, $cat_id));
        $munits             = (!$settings->measurement_units) ? _IP_CBLISTINGS_SQFT : _IP_CBLISTINGS_SQM;
        $new                = ipropertyHTML::isNew($p->created, $settings->new_days);
        $updated            = ipropertyHTML::isNew($p->modified, $settings->updated_days);
        $border             = ($p->featured) ? ' border: solid 1px ' . $settings->featured_accent . ';' : '';
        $span_style         = ($p->featured) ? ' style="color: ' . $settings->featured_accent . ';"' : '';
        //include($_CB_framework->getCfg( 'absolute_path' ).'/components/com_iproperty/views/property/tmpl/default_overview.php');

        $display = '
        <tr class="iprow'.$k.'">
            <td width="10%" valign="top">
                <div class="property_thumb_holder" style="width: '.$thumb_width.'; height: '.$thumb_height.';'.$border.'">
                    '.ipropertyHTML::displayBanners($p->stype, $new, $ipbaseurl, $settings, $updated).
                    ipropertyHTML::getThumbnail($p->id, $plink, $p->street_address, $thumb_width, 'class="ip_overview_thumb"').'
                </div>
                <div class="prop_overview_price" align="right">
                    '.$p->formattedprice.'
                </div>
            </td>
            <td width="90%" valign="top">
                <div class="property_overview_mlstitle">';
                    if( $p->featured ):
                            $display .= '
                            <div class="property_overview_bannerright" align="right">
                                <img src="'.$ipbaseurl.'/components/com_iproperty/assets/images/banners/banner_hot.png" alt="'._IP_CBLISTINGS_FEATURED.'" title="'._IP_CBLISTINGS_FEATURED.'" />
                            </div>';
                    endif;
        $display .= '
                </div>
                <div class="property_overview_title">
                    <a href="'.$plink.'"'.$span_style.' class="property_header_accent">'.$p->street_address.'</a>';
                        if( $p->city ) $display .= ' - '.$p->city;
                        if( $p->locstate ) $display .= ', ' . ipropertyHTML::getstatename($p->locstate);
                        if( $p->province ) $display .= ', ' . $p->province;
                        if( $p->country ) $display .= ' ' . ipropertyHTML::getcountryname($p->country);
                        echo '<br />';

                        $display .= '<em>';
                        if( $p->beds ) $display .= '<strong>' ._IP_CBLISTINGS_BEDS.':</strong> ' . $p->beds . ' &nbsp;&nbsp;';
                        if( $p->baths && $p->baths != '0.00' ) $display .= '<strong>' ._IP_CBLISTINGS_BATHS.':</strong> ' . $p->baths . ' &nbsp;&nbsp;';
                        if( $p->sqft ) $display .= '<strong>' .$munits.':</strong> ' . $p->sqft . ' &nbsp;&nbsp;';
                        if( $p->lotsize ) $display .= '<strong>' ._IP_CBLISTINGS_LOTSIZE.':</strong> ' . $p->lotsize . ' &nbsp;&nbsp;';
                        if( $p->lot_acres ) $display .= '<strong>' ._IP_CBLISTINGS_LOTACRES.':</strong> ' . $p->lot_acres . ' &nbsp;&nbsp;';
                        if( $p->county ) $display .= '<strong>' ._IP_CBLISTINGS_COUNTY.':</strong> ' . $p->county . ' &nbsp;&nbsp;';
                        if( $p->region ) $display .= '<strong>' ._IP_CBLISTINGS_REGION.':</strong> ' . $p->region . ' &nbsp;&nbsp;';
                        $display .= '</em>
                </div>';
                    $property_desc = ($p->short_description) ? $p->short_description : strip_tags($p->description);
                    $overview_char = ($settings->overview_char) ? $settings->overview_char : 250;
                    (strlen($property_desc) >= $overview_char ) ? $property_short_display = substr( $property_desc, 0, $overview_char )  . '...' : $property_short_display = $property_desc;
                    $display .= $property_short_display;
                    if (ipropertyHTML::getCompanyName($p->listing_office)) {
                        if ($p->created != '0000-00-00'){
                            $listing_info = _IP_CBLISTINGS_LISTEDBY.' '.ipropertyHTML::getCompanyName($p->listing_office).' '._IP_CBLISTINGS_ON.' '.$p->fcreated;
                        } else {
                            $listing_info = _IP_CBLISTINGS_LISTEDBY.' '.ipropertyHTML::getCompanyName($p->listing_office);
                        }
                    } elseif ($p->listing_info) {
                        $listing_info = _IP_CBLISTINGS_LISTEDBY.' '.$p->listing_info;
                    } else {
                        $listing_info = '';
                    }
                    $last_updated = ($p->last_updated && $updated) ? _IP_CBLISTINGS_LASTMODIFIED.': '.$p->last_updated : '';
        $display .= '
                <div class="ip_smallfont">'.$listing_info.'  ['.ipropertyHTML::get_stype($p->stype).'] '.$last_updated.'</div>
            </td>
        </tr>';
        return $display;
    }
} // end of gethelloworldTab class
?>