<?php
/**
 * @version 2.0 2012-01-20
 * @package Joomla
 * @subpackage PhocaPDF
 * @copyright (C) 2012 the StarTech
 * @license GNU/GPL see LICENSE.php
 */

defined('_JEXEC') or die('Restricted access');
jimport('joomla.filesystem.file');

if (JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_phocapdf'.DS.'helpers'.DS.'phocapdfbrowser.php')) {
	require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_phocapdf'.DS.'helpers'.DS.'phocapdfbrowser.php');
} else {
	return JError::raiseError('PDF ERROR', 'Document cannot be created - Loading of Phoca PDF Helper Browser failed');
}
require_once(JPATH_SITE.DS.'components'.DS.'com_iproperty'.DS.'helpers'.DS.'html.helper.php');
require_once(JPATH_SITE.DS.'components'.DS.'com_iproperty'.DS.'helpers'.DS.'property.php');
require_once(JPATH_SITE.DS.'components'.DS.'com_iproperty'.DS.'helpers'.DS.'query.php');
require_once(JPATH_SITE.DS.'components'.DS.'com_iproperty'.DS.'helpers'.DS.'route.php');
require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_iproperty'.DS.'classes'.DS.'admin.class.php');

class PhocaPDFIpropertyHelper {

	function renderPDFIcon(){

		$lang 			= JFactory::getLanguage();
		$lang->load('plg_phocapdf_iproperty', JPATH_ADMINISTRATOR, null, true);

		$browser 	= PhocaPDFHelperBrowser::browserDetection('browser');

		// Call abstract view to not load all iproperty content and save memory
		$href		= 'index.php?option=com_phocapdf&view=pdf&format=phocapdf&type=iproperty&prop_id='.JRequest::getInt('id').'&tmpl=component&format=pdf';

		if ($browser == 'msie7' || $browser == 'msie8') {
			$onClick = '';
			$target	 = ' target="_blank"';
		} else {
			$onClick= ' onclick="window.open(this.href,\'win2\',\'status=no,'
			.'toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,'
			.'width=640,height=480,directories=no,location=no\'); return false;"';
			$target	= '';
		}

		$link = '<div class="ip_phocapdf_icon" style="margin-top: 8px; text-align: right;">
                    <a href="'.$href.'"'.$onClick.$target.'>'.JHtml::_('image', 'administrator/components/com_phocapdf/assets/images/icon-16-pdf.png', JText::_('PLG_PHOCAPDF_IP_PDF')). '</a>
                 </div>';

		echo $link;
	}

    function dbQ ($prop_id = '', $type = 'property') {
        $db         = JFactory::getDBO();

        switch($type){
            case 'property':
            default:
                $where      = 'p.id = '.(int)$prop_id;
                $property   = new ipropertyHelperproperty($db);
                $property->setType('property');
                $property->setWhere( $where );
                $result     = $property->getProperty();

                $result     = $result[0];

                $company = ipropertyHelperQuery::buildCompany($result->listing_office);
                $result->company_logo = $company->icon;
                $result->company_name = $company->name;
                $result->company_phone = $company->phone;
                $result->company_email = $company->email;
                return $result;
            break;

            case 'images':
                $query = "SELECT *, title AS img_title, description AS img_description FROM #__iproperty_images WHERE propid = ".(int)$prop_id." AND (type = '.jpg' OR type = '.jpeg' OR type = '.gif' OR type = '.png') ORDER BY ordering ASC";
                $db->setQuery($query);

                $result = $db->loadObjectList();
                return $result;
            break;

            case 'settings':
                $query = 'SELECT * FROM #__iproperty_settings WHERE id = 1';
                $db->setQuery($query);

                $result = $db->loadObject();
                return $result;
            break;

            case 'agents':
                $agents  = ipropertyHTML::getAvailableAgents($prop_id);
                return $agents;
            break;
        }
	}
}
