<?php
/**
 * @version 2.0 2012-01-20
 * @package Joomla
 * @subpackage PhocaPDF
 * @copyright (C) 2012 the StarTech
 * @license GNU/GPL see LICENSE.php
 */

defined('_JEXEC') or die('Restricted access');
jimport('joomla.filesystem.file');
require_once(JPATH_ROOT.DS.'plugins'.DS.'phocapdf'.DS.'iproperty'.DS.'iproperty'.DS.'ipropertyhelper.php');
require_once(JPATH_ROOT.DS.'plugins'.DS.'phocapdf'.DS.'iproperty'.DS.'iproperty'.DS.'tmpl.property.php');

class PhocaPDFIpropertyPdfOutput {

	/* Output Header */
	public function getOutputHeader($pluginParams, $staticData = array()) {

		$lang 	= JFactory::getLanguage();
		$lang->load('plg_phocapdf_iproperty', JPATH_ADMINISTRATOR, null, true);

		$request		= JRequest::get('request');
		//Document is not rendered in browser, we need to get static data not set by request but by function
		if(isset($staticData['prop_id']) && (int)$staticData['prop_id'] > 0) {
			$request['prop_id']	= (int)$staticData['prop_id'];
		}
		if (isset($staticData['type']) && $staticData['type'] != '') {
			$request['type']	= $staticData['type'];
		}

		// Get info from db
		$property	= PhocaPDFIpropertyHelper::dbQ($request['prop_id']);
        $images 	= PhocaPDFIpropertyHelper::dbQ($request['prop_id'], 'images');
        $settings 	= PhocaPDFIpropertyHelper::dbQ('', 'settings');

		$params['css'] = $pluginParams->get('css_header', '');
        $params['property'] = $property;
        if(count($images) && $pluginParams->get('display_image', '')) $params['images'] = $images;
        $params['settings'] = $settings;

        $output = PhocaPDFIpropertyProperty::getOutputHeader($params);
        $output = plgPhocaPDFIproperty::correctImgPath($output);

		// trying this here
		$output = str_replace(DS, '/', $output);
        
		return $output;
	}

    /* Outupt Property Details */
	public function getOutput($staticData = array()) {

		$plugin             =JPluginHelper::getPlugin('phocapdf', 'iproperty');
	 	$pluginParams       = new JParameter( $plugin->params );

		$lang               = JFactory::getLanguage();
		$lang->load('plg_phocapdf_iproperty', JPATH_ADMINISTRATOR, null, true);

        $request			= JRequest::get('request');
		//Document is not rendered in browser, we need to get static data not set by request but by function
		if(isset($staticData['prop_id']) && (int)$staticData['prop_id'] > 0) {
			$request['prop_id']	= (int)$staticData['prop_id'];
		}
		if (isset($staticData['type']) && $staticData['type'] != '') {
			$request['type']	= $staticData['type'];
		}

		// Get info from db
		$property	= PhocaPDFIpropertyHelper::dbQ($request['prop_id']);
        $images 	= PhocaPDFIpropertyHelper::dbQ($request['prop_id'], 'images');
        $agents     = PhocaPDFIpropertyHelper::dbQ($request['prop_id'], 'agents');
        $settings 	= PhocaPDFIpropertyHelper::dbQ('', 'settings');

		$params['css'] = $pluginParams->get('css_site', '');
        $params['property'] = $property;
        if(count($images) && $pluginParams->get('display_image', '')) $params['images'] = $images;
        if(count($agents) && $pluginParams->get('display_agent', '')) $params['agents'] = $agents;
        $params['settings'] = $settings;

        $output = PhocaPDFIpropertyProperty::getOutput($params);
		$output = plgPhocaPDFIproperty::correctImgPath($output);

		// trying this here
		$output = str_replace(DS, '/', $output);

		// PDF Document
        $outputArray['output']      = $output;
		$outputArray['title'] 		= JText::_('IProperty').' - '.$property->street_address;
		if(isset($typeLabel)) {
			$outputArray['subject']		= $typeLabel;
			$outputArray['keywords']	= $typeLabel;
		} else {
			$outputArray['subject']		= '';
			$outputArray['keywords']	= '';
		}

		return $outputArray;
	}

	/* Output Footer */
	public function getOutputFooter($pluginParams, $staticData = array()) {

		$lang 	= JFactory::getLanguage();
		$lang->load('plg_phocapdf_iproperty', JPATH_ADMINISTRATOR, null, true);

		$request		= JRequest::get('request');
		//Document is not rendered in browser, we need to get static data not set by request but by function
		if(isset($staticData['prop_id']) && (int)$staticData['prop_id'] > 0) {
			$request['prop_id']	= (int)$staticData['prop_id'];
		}
		if (isset($staticData['type']) && $staticData['type'] != '') {
			$request['type']	= $staticData['type'];
		}

		// Property
		$property	= PhocaPDFIpropertyHelper::dbQ($request['prop_id']);

		$params = array();
		$params['listing_office']	= ipropertyHTML::getCompanyName($property->listing_office);
		$params['proplink']         = $property->proplink;
		$params['css']				= $pluginParams->get('css_footer', '');

        $output = PhocaPDFIpropertyProperty::getOutputFooter($params);
		return $output;
	}

	/**************************************************************************
	 * name: exists_and_is_numeric
	 * created by: ingemar
	 * description: Checks an array of items if they exists and is numeric
	 * parameters: Array of names and keys, Data
	 * returns:
	 **************************************************************************/
	function exists_and_is_numeric( $check, &$request ) {
		foreach( $check as $key => $value ) {
			if( isset( $request[$value] ) && !is_numeric( $request[$value] ) ) {
				$request["error"] = 'The '.$key.' '.$request[$value].' is not valid.';
				return False;
			}
			elseif( !isset( $request[$value] ) ) {
				$request["error"] = 'Missing '.$key;
				return False;
			}
		}
		return True;
	}
}
?>
