<?php
/**
 * @version 2.0 2012-01-20
 * @package Joomla
 * @subpackage PhocaPDF
 * @copyright (C) 2012 the StarTech
 * @license GNU/GPL see LICENSE.php
 */

defined('_JEXEC') or die('Restricted access');
jimport('joomla.filesystem.file');

class PhocaPDFIpropertyProperty {

	public function getOutputHeader($p) {
		$lang = JFactory::getLanguage();
		$lang->load('plg_phocapdf_iproperty', JPATH_ADMINISTRATOR, null, true);

        $settings = $p['settings'];
        $property = $p['property'];
        if(isset($p['images'])) $images   = $p['images'];

        $mainimage = ipropertyHTML::getThumbnail($property->id, '', $property->street_address, 500, 'class="ip_phocacontent_mainimg"', '', false );
        $mainimage = str_replace(DS, '/', $mainimage);
        $mainimage = str_replace(JURI::root(true), '', $mainimage);
        $company_logo = 'media/com_iproperty/companies/' . $property->company_logo;

        if($property->short_description){
            $description = (strlen($property->short_description) > 270 ) ? substr($property->short_description, 0, 270) . '. . .' : $property->short_description;
        }else if($property->description){
            $description = substr($property->description, 0, 270) . '. . .';
        }

		$output = '<style>'.$p['css'].'</style>';

        // Do not remove <p></p> from the following. Added because of tcpdf bug in 19490 undefined offset
		$output .=
            '<p></p>
             <table class="ip_phocacontent" cellpadding="2" cellspacing="2">
                <tr>';
                    $colspan = '';
                    if($property->company_logo && $property->company_logo != 'nopic.png'){
                        $output .= '<td class="ip_phocacontent_cologo" valign="top"><img src="'.$company_logo.'" alt="" align="left" class="ip_phocacontent_coimage" /></td>';
                    }else{
                        $colspan = 2;
                    }
        $output .= '
                    <td class="ip_phocacontent_coinfo" valign="top"'.$colspan.'>';
                        if($property->company_name) $output .= '<span class="ip_phocacontent_companyheader">'.$property->company_name.'</span>';
                        if($property->company_phone) $output .= '<br />'.$property->company_phone;
                        if($property->company_email) $output .= '<br />'.$property->company_email;
        $output .= '
                    </td>
                </tr>
             </table>
             <table class="ip_phocacontent" cellpadding="2" cellspacing="2">
                <tr width="100%">
                    <td width="45%">
                        '.$mainimage.'
                    </td>
                    <td width="55%" valign="top">
                        <span class="ip_phocacontent_header">'.$property->street_address.'</span><br />
                        '.$description.'<br /><br />
                        '.ipropertyHTML::getFullAddress($property->street_address, $property->city, $property->locstate, $property->province, $property->zip, $property->country).'
                    </td>
                </tr>';
        $output .= '
            </table>
            <div></div>';
		return $output;
	}

    public function getOutput($p) {

		$lang = JFactory::getLanguage();
		$lang->load('plg_phocapdf_iproperty', JPATH_ADMINISTRATOR, null, true);

        $settings 	= (isset($p['settings'])) ? $p['settings'] : '';
        $property 	= (isset($p['property'])) ? $p['property'] : '';
        $images   	= (isset($p['images'])) ? $p['images'] : '';
        $agents   	= (isset($p['agents'])) ? $p['agents'] : '';

        if(!$property) return;

        $co_info = '';
        foreach( $agents as $a ):
            $co_info .= PhocaPDFIpropertyProperty::agentDetails($a, $settings);
        endforeach;

        // Google Map
        if ( $property->lat_pos == '' || $property->long_pos == '' || !function_exists('curl_init')){
            $googleimage = '<br />'.JText::_('NO MAP AVAILABLE');
        } else {
            $latitude = $property->lat_pos;
            $longitude = $property->long_pos;

            $address = '';
            $address .= ($property->city) ? $property->city : '';
            $address .= ($property->locstate) ? ', '.ipropertyHTML::getStateName($property->locstate) : '';
            $address .= ($property->province) ? $property->province : '';
            $address .= ($property->country) ? ', '.ipropertyHTML::getCountryName($property->country) : '';
            if( $address == '' ) $address = 'N/A';
            $address .= '<br /><br />';

            $url_address = urlencode(str_replace('<br />', ' ', $address));
            $google_map_string = "http://maps.google.com/maps/api/staticmap?center=" . trim($latitude) . "," . trim($longitude) . "&size=512x500&maptype=roadmap&markers=color:red|" . trim($latitude) . "," . trim($longitude) . "&format=png32&sensor=false";


            //if($curlimage = self::curlImage($google_map_string)){
                //$mapdisplay = '<p><img src="'.$curlimage.'" /></p>';
            //}else{
                $mapdisplay = 'No map available';
            //}
            $google_map_link = "http://maps.google.com/maps?q= $url_address";
            //$googleimage = $this->_pdf->Image($curlimage,15,$g_y,90,80,'PNG',$google_map_link);
        }

		$output = '<style>'.$p['css'].'</style>';
        // Do not remove <p></p> from the following. Added because of tcpdf bug in 19490 undefined offset
		$output .=
            '<p></p>
             <table class="ip_phocacontent" cellpadding="2" cellspacing="2">
                <tr width="100%">
                    <td width="45%">
                        '.$mapdisplay.'
                    </td>
                    <td width="55%">
                        <p>'.$co_info.'</p>
                    </td>
                </tr>';
                if (isset($images) && count($images) > 1){
                    $output .= '<tr>
                                    <td colspan="2">
                                        <table class="ip_phocacontent_thumbs" cellpadding="0" cellspacing="2">
                                            <tr>';
                                            $imgcnt = 0;
                                            foreach($images as $image) {
                                                $gpath          = ($image->remote == 1) ? $image->path : $settings->imgpath;
                                                $gthumbnail     = ($image->remote == 1) ? $gpath.$image->fname.$image->type : $gpath.$image->fname. '_thumb' . $image->type;

                                                $output .= '<td><div class="ip_thumb_container"><img src="'.$gthumbnail.'" border="0" alt="'.$property->street_address.'" width="70" /></div>&nbsp;</td>';
                                                $imgcnt++;
                                                if($imgcnt >= 5) break;
                                            }
                    $output .=             '</tr>
                                        </table>
                                    </td>
                                </tr>';
                }
        $output .= '
            </table>
            <div></div>';
		return $output;
	}

	public function getOutputFooter($params) {

		$lang = JFactory::getLanguage();
		$lang->load('plg_phocapdf_iproperty', JPATH_ADMINISTRATOR, null, true);

		$output = '<style>'.$params['css'].'</style>';
		$output .=
            '<p></p>
             <table class="ipfooter" cellpadding="5">
                <tr width="100%" >
                    <td width="30%">
                        <span class="ip_itemhead">'.JText::_('PLG_PHOCAPDF_IP_LISTING_OFFICE').':</span><br /><span class="ip_itemelement">'.$params['listing_office'].'</span>
                    </td>
                    <td width="70%">
                        <span class="ip_itemhead">'.JText::_('PLG_PHOCAPDF_IP_LINK') .':</span><br /><span class="ip_itemelement">'.JURI::base().$params['proplink'].'</span>
                    </td>
                </tr>
            </table>';
		return $output;
	}

    function curlImage($url){
        if(!function_exists('curl_init')) return "curl not available";
		$app = JFactory::getApplication();
		$tmp_path = $app->getCfg('tmp_path');

        $ext = self::getExtension($url);

		$temp = $tmp_path . DS . 'map' . mt_rand() . '.' . $ext;
		$fh = fopen($temp, "w");

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_BINARYTRANSFER,1);
		curl_setopt($ch, CURLOPT_FILE, $fh);

		$data = curl_exec($ch);
		curl_close($ch);
		fclose($fh);

		return $temp;
    }

    function getExtension($filename){
        $pathparts = pathinfo($filename);
        switch(strtolower($pathparts['extension'])){
            case 'jpg':
                return 'jpg';
                break;
            case 'jpeg':
                return 'jpg';
                break;
            case 'jpe':
                return 'jpg';
                break;
            case 'png':
                return 'png';
                break;
            case 'gif':
                return 'gif';
                break;
            default:
                return 'jpg';
                break;
        }
        return false;
    }

    function agentDetails($agent, $c){
        //return 'agent info';
        $a_info = '<table width="100%" cellpadding="2" cellspacing="2">
                     <tr>';
        if($agent->icon){
            $a_info .= '<td width="30%"><img src="media/com_iproperty/agents/'.$agent->icon . '" width="50" /></td>';
        }
        $a_info .= '<td width="70%"><b>' . $agent->agent_name . '</b><br />';
        $a_info .= $agent->companyname.'<br />';
        if($agent->email && $c->agent_show_email) $a_info .= '<b>' . JText::_('PLG_PHOCAPDF_IP_EMAIL') . ':</b> '.$agent->email.'<br />';
        if($agent->phone && $c->agent_show_phone) $a_info .= '<b>' . JText::_('PLG_PHOCAPDF_IP_PHONE') . ':</b> '.$agent->phone . '<br />';
        $a_info .= '</td>
                    </tr>
                  </table>';

        return $a_info;
    }
}
?>
