<?php
/**
 * @version 2.0 2012-01-20
 * @package Joomla
 * @subpackage Intellectual Property
 * @copyright (C) 2012 the StarTech
 * @license GNU/GPL see LICENSE.php
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.plugin.plugin');

class plgIpropertyCurrencyTab extends JPlugin
{
	function plgIpropertyCurrencyTab(&$subject, $config)  
    {
		parent::__construct($subject, $config);
        $this->loadLanguage();
	}

	function onAfterRenderMap($property, $settings, $height, $width, $accent)
	{
        $app = JFactory::getApplication();
        if($app->getName() != 'site') return true;

        // currencies supported by Google as of 09/2010
        $currencies = array (
            "EUR" => "евро (EUR)",
            "RUB" => "росийский рубль (RUB)",
            "CNY" => "китайский юань (CNY)",
            "GBP" => "Британский фунт (GBP)",
            "USD" => "доллар США (USD)",
            "JPY" => "японские иены (JPY)",
            "UAH" => "украинская гривна (UAH)",
            
                 );

        asort($currencies);

        // get site's normal currency and check that it's in the Google array
        $start_curr = $settings->default_currency;
        if(!array_key_exists($start_curr, $currencies)) return true; // not in array so bail out

        // if "call for price" obviously we can't do a conversion so bail out
        if($property->formattedprice == JText::_('COM_IPROPERTY_CALL_FOR_PRICE')) return true;

        // else we can do this so get the price
        $price = $property->price;

        // create javascript for ajax request
        $javascript = "
        window.addEvent('domready', function() {
            $('currency_select').addEvent('change', function(event) {
                var curr = $('currency_select').value;
                var price = '" . $price . "';

                var url = '" . JURI::root(true) . "/plugins/iproperty/currencytab/currencytab_proxy.php?vars=1" . $start_curr . "%3D%3F' + curr + '&price=' +price;
                var request = new Request.JSON({
                    url: url,
                    onComplete: function(jsonObj) {
                        if(typeof(jsonObj) !== 'undefined'){
                            $('new_price').set('html', jsonObj + ' ' + curr );
                        }else{
                            $('new_price').set('html', '--' );
                        }
                    }
                }).get();
            });
        });";

        $doc = JFactory::getDocument();
        $doc->addScriptDeclaration($javascript);

        $currencies_list   = array();
        $currencies_list[] = JHTML::_('select.option', '', JText::_('PLG_IP_CONVERT_CURRENCY'), 'id', 'name' );

        foreach($currencies as $key => $value){
            $currencies_list[] = JHTML::_('select.option', $key, $value, 'id', 'name' );
        }

        $curr_select  = JHTML::_('select.genericlist', $currencies_list, 'currency_select', 'class="inputbox"', 'id', 'name', 'currency_select' );

        echo JHtml::_('tabs.panel', JText::_($this->params->get('tabtitle', 'PLG_IP_CONVERT_CONVERT')), 'ip_currency');
            echo '
                <div class="ip_spacer"></div>
                <div id="ip_currency_wrapper" style="height:'.$height.'px; width: '.$width.'px; overflow: auto; background: '.$accent.';">
                    <div class="ip_currency_wrapper2" style="padding: 8px;" align="center">
                    <table width="100%" class="ip_favorites">
                        <tr>
                            <td colspan="2" align="center">
                                <b>'.JText::_('PLG_IP_CONVERT_SELECT_CURRENCY').':</b><br />
                                '.$curr_select.'
                            </td>
                        </tr>
                        <tr bgcolor="' . $settings->accent . '">
                            <th width="50%">'.JText::_('PLG_IP_CONVERT_CURRENT_PRICE').'</th>
                            <th width="50%">'.JText::_('PLG_IP_CONVERT_NEW_PRICE').'</th>
                        </tr>
                        <tr>
                            <td align="center">'.ipropertyHTML::getFormattedPrice($price).'</td>
                            <td align="center"><span id="new_price">--</span></td>
                        </tr>
                    </table>
                    </div>
                </div>';
        return true;
	}
}
