<?php
/**
 * @version 2.0 2012-01-20
 * @package Joomla
 * @subpackage Intellectual Property
 * @copyright (C) 2012 the StarTech
 * @license GNU/GPL see LICENSE.php
 */

defined( '_JEXEC' ) or die( 'Restricted access' );
require_once (JPATH_ADMINISTRATOR.DS.'components'.DS.'com_iproperty'.DS.'classes'.DS.'admin.class.php' );
require_once (JPATH_SITE.DS.'components'.DS.'com_iproperty'.DS.'helpers'.DS.'auth.php' );

class IpropertyHTML 
{
    function buildToolbar($view = '', $extras = '') 
    {
        JHtml::addIncludePath(JPATH_COMPONENT . '/helpers');
        $settings   = ipropertyAdmin::config();

        if( $extras ){
            foreach( $extras as $key=>$value ){
                $this->$key = $value;
            }
        }

        $ipversion = ipropertyAdmin::_getversion();
        $html = "<!-- Iproperty v".$ipversion['iproperty']." by The StarTech. http://thethinkery.net -->\n";
        if(JRequest::getInt('print') == 1){
            $html .= '<div align="center">
                        <script language="JavaScript">
                            if (window.print) {
                                document.write(\'<form><input type="button" class="inputbox" name="print" value="'.JText::_( 'COM_IPROPERTY_PRINT' ).'" onClick="window.print()"></form>\');
                            }
                        </script>
                      </div>';
        }else{
            $html .= '<div id="ip_toolbar" style="background: ' . $settings->accent . ';">';
            $html .= '<a href="javascript:history.back();">'.JText::_( 'COM_IPROPERTY_BACK' ).'</a>';
                switch( $view ){
                    // PROPERTY VIEW TOOLBAR :::: VIEWING ACTUAL PROPERTY DETAILS
                    case 'property':
                        if($this->ipauth->canEditProp($this->property->id)){
                            $html .= JHtml::_('icon.edit',  $this->property, 'property', true);
                        }
                        if( $settings->show_print ){
                            $urlPrint = JRoute::_('&print=1');
                            $html   .= '<a href="' . $urlPrint . '" class="hasTip modal" title="'.JText::_( 'COM_IPROPERTY_PRINT' ).' :: '.JText::_( 'COM_IPROPERTY_PRINT_TIP' ).'" rel="{handler: \'iframe\', size: {x: 650, y: 750}}">'.JText::_( 'COM_IPROPERTY_PRINT' ).'</a>';
                        }
                        if( $settings->show_saveproperty ){
                            $html   .= '<a href="#" id="saveslidein">'.JText::_( 'COM_IPROPERTY_SAVE' ).'</a>';
                        }
                        if( $settings->show_mtgcalc ){
                            $html   .= '<a href="#" id="calcslidein">'.JText::_( 'COM_IPROPERTY_CALCULATE_MORTGAGE' ).'</a>';
                        }
                    break;

                    // CATEGORY TOOLBAR :::: ON CATEGORY LISTINGS DISPLAY
                    case 'allproperties':
                    case 'cat':
                    case 'companyproperties':
                    case 'agentproperties':
                    case 'openhouses':
                        if( $settings->rss ){
                            $document = JFactory::getDocument();
                            $link = '&format=feed&limitstart=';
                            $attribs = array('type' => 'application/rss+xml', 'title' => 'RSS 2.0');
                            $document->addHeadLink(JRoute::_($link.'&type=rss'), 'alternate', 'rel', $attribs);
                            $attribs = array('type' => 'application/atom+xml', 'title' => 'Atom 1.0');
                            $document->addHeadLink(JRoute::_($link.'&type=atom'), 'alternate', 'rel', $attribs);
                            $urlRss = JRoute::_($link.'&type=rss');
                            $html .= '<a href="'.$urlRss.'" class="hasTip" title="'.JText::_('RSS').' :: '.JText::_('COM_IPROPERTY_RSS_TIP').'" target="_blank">'.JText::_('RSS').'</a>';
                        }
                    break;
                }
            $html .= ( $view != 'ipuser' && $settings->show_saveproperty ) ? '<a href="'.JRoute::_(ipropertyHelperRoute::getIpuserRoute()).'" class="hasTip" title="'.JText::_( 'COM_IPROPERTY_MY_FAVORITES' ).' :: '.JText::_( 'COM_IPROPERTY_MY_FAVORITES_TIP' ).'">'.JText::_( 'COM_IPROPERTY_MY_FAVORITES' ).'</a>' : '';
            $html .= ( $view != 'advsearch' && $settings->googlemap_enable ) ? '<a href="'.JRoute::_(ipropertyHelperRoute::getAdvsearchRoute()).'">'.JText::_( 'COM_IPROPERTY_SEARCH' ).'</a>' : '';
            $html .= '</div>';
            $html .= '<div class="ipclear"></div>';
        }
        return $html;
    }

    /**
     * Substr replacement, doesn't break words in the middle
     */
    function snippet($text, $length = 200, $tail = "(...)") 
    {
       $text = trim($text);
       $txtl = strlen($text);
       if($txtl > $length) {
           for($i = 1; $text[$length-$i] != " "; $i++) {
               if($i == $length) {
                   return substr($text, 0, $length) . $tail;
               }
           }
           $text = substr($text, 0, $length-$i+1) . $tail;
       }
       return $text;
    }

    function buildNoResults($accent_color, $wrapper = null)
    {
        $ipbaseurl = JURI::root(true);
        $html = '';
        if( $wrapper ) $html .= '<table class="ptable">';
        $html .= '<tr>
                     <td colspan="2" align="center">
                        <div class="pe_noresults" style="border-color: ' . $accent_color . ';">
                            '.JHTML::_('image.site', 'iproperty1.png','/components/com_iproperty/assets/images/','','',JText::_( 'COM_IPROPERTY_NO_RECORDS' )).'
                            <br />
                            ' . JText::_( 'COM_IPROPERTY_NO_RECORDS_TEXT' ) . '
                        </div>
                    </td>
                 </tr>';
        if( $wrapper ) $html .= '</table>';

        return $html;
    }

    function buildThinkeryFooter($accent_color)
    {
        $ipversion = ipropertyAdmin::_getversion();
        return '<div class="property_footer">'.JText::_( 'COM_IPROPERTY_PROPERTY_AGENT_FOOTER' ).' <a href="http://www.jarosstar.com" target="_blank" style="color: ' . $accent_color . ';">StarTech</a>.  v'.$ipversion['iproperty'].'</div>';
    }

    function sentence_case($string) 
    {
        $sentences = preg_split('/([.?!]+)/', $string, -1, PREG_SPLIT_NO_EMPTY|PREG_SPLIT_DELIM_CAPTURE);
        $new_string = '';
        foreach ($sentences as $key => $sentence) {
            $new_string .= ($key & 1) == 0?
            ucfirst(strtolower(trim($sentence))) :
            $sentence.' ';
        }
        return trim($new_string);
    }

    function buildSortList($filter_order, $attrib = '', $listonly = false, $tag = false)
    {
        $settings = ipropertyAdmin::config();
        $munits   = (!$settings->measurement_units) ? JText::_( 'COM_IPROPERTY_SQFTDD' ) : JText::_( 'COM_IPROPERTY_SQMDD' );
        $sortbys = array();
        if($settings->showtitle){
            $sortbys[] = JHTML::_('select.option', 'p.title', JText::_( 'COM_IPROPERTY_TITLE' ) );
        }else{
            $sortbys[] = JHTML::_('select.option', 'p.street', JText::_( 'COM_IPROPERTY_STREET' ) );
        }
        $sortbys[] = JHTML::_('select.option', 'p.beds', JText::_( 'COM_IPROPERTY_BEDS' ) );
        $sortbys[] = JHTML::_('select.option', 'p.baths', JText::_( 'COM_IPROPERTY_BATHS' ) );
        $sortbys[] = JHTML::_('select.option', 'p.sqft', $munits );
        $sortbys[] = JHTML::_('select.option', 'p.price', JText::_( 'COM_IPROPERTY_PRICE' ) );
        $sortbys[] = JHTML::_('select.option', 'p.created', JText::_( 'COM_IPROPERTY_LISTED_DATE' ) );
        $sortbys[] = JHTML::_('select.option', 'p.modified', JText::_( 'COM_IPROPERTY_MODIFIED_DATE' ) );

        $tag = ($tag) ? $tag : 'filter_order';

        if($listonly){
            return $sortbys;
        }else{
            return JHTML::_('select.genericlist', $sortbys, $tag, $attrib, 'value', 'text', $filter_order );
        }
    }

    function buildAgentSortList($filter_order, $attrib = '', $listonly = false, $tag = false)
    {
        $sortbys = array();
        $sortbys[] = JHTML::_('select.option', 'a.ordering', JText::_( 'COM_IPROPERTY_SELECT' ) );
        $sortbys[] = JHTML::_('select.option', 'a.lname', JText::_( 'COM_IPROPERTY_LAST_NAME' ) );
        $sortbys[] = JHTML::_('select.option', 'a.fname', JText::_( 'COM_IPROPERTY_FIRST_NAME' ) );
        if(JRequest::getVar('view') == 'agents') $sortbys[] = JHTML::_('select.option', 'c.id', JText::_( 'COM_IPROPERTY_COMPANY' ) );

        $tag = ($tag) ? $tag : 'filter_order';

        if($listonly){
            return $sortbys;
        }else{
            return JHTML::_('select.genericlist', $sortbys, $tag, $attrib, 'value', 'text', $filter_order );
        }
    }

    function buildCompanySortList($filter_order, $attrib = '', $listonly = false, $tag = false)
    {
        $sortbys = array();
        $sortbys[] = JHTML::_('select.option', 'ordering', JText::_( 'COM_IPROPERTY_SELECT' ) );
        $sortbys[] = JHTML::_('select.option', 'name', JText::_( 'COM_IPROPERTY_NAME' ) );
        $sortbys[] = JHTML::_('select.option', 'city', JText::_( 'COM_IPROPERTY_CITY' ) );

        $tag = ($tag) ? $tag : 'filter_order';

        if($listonly){
            return $sortbys;
        }else{
            return JHTML::_('select.genericlist', $sortbys, $tag, $attrib, 'value', 'text', $filter_order );
        }
    }

    function buildOrderList($filter_order_dir, $attrib = '', $listonly = false, $tag = false)
    {
        $orderbys = array();
        $orderbys[] = JHTML::_('select.option', 'ASC', JText::_( 'COM_IPROPERTY_ASCENDING' ) );
        $orderbys[] = JHTML::_('select.option', 'DESC', JText::_( 'COM_IPROPERTY_DESCENDING' ) );

        $tag = ($tag) ? $tag : 'filter_order_dir';

        if($listonly){
            return $orderbys;
        }else{
            return JHTML::_('select.genericlist', $orderbys, $tag, $attrib, 'value', 'text', $filter_order_dir );
        }
    }

    function getCountryName($country)
    {
        $db = JFactory::getDbo();
        
        $query = $db->getQuery(true);
        $query->select('title')
            ->from('#__iproperty_countries')
            ->where('id = '.(int)$country);

        $db->setQuery($query, 0, 1);
        $result = $db->loadResult();

        return $result;
    }

    function getStateName($state)
    {
        $db = JFactory::getDbo();
        
        $query = $db->getQuery(true);
        $query->select('title')
            ->from('#__iproperty_states')
            ->where('id = '.(int)$state);

        $db->setQuery($query, 0, 1);
        $result = $db->loadResult();

        return $result;
    }

    function getStateCode($state)
    {
        $db = JFactory::getDbo();
        
        $query = $db->getQuery(true);
        $query->select('mc_name')
            ->from('#__iproperty_states')
            ->where('id = '.(int)$state);

        $db->setQuery($query, 0, 1);
        $result = $db->loadResult();

        return $result;
    }

    function getCompanyName($co)
    {
        $db = JFactory::getDbo();
        
        $query = $db->getQuery(true);
        $query->select('name')
            ->from('#__iproperty_companies')
            ->where('id = '.(int)$co);
        
        $db->setQuery($query, 0, 1);
        $result = $db->loadResult();
        
        return $result;
    }

    function getCompanyEmail($co) 
    {
        $db = JFactory::getDbo();
        
        $query = $db->getQuery(true);
        $query->select('email')
            ->from('#__iproperty_companies')
            ->where('id = '.(int)$co);
        
        $db->setQuery($query, 0, 1);
        $result = $db->loadResult();
        
        return $result;
    }

    function getAvailableCats( $id = null )
    {
        $db = JFactory::getDbo();
        
        $query = $db->getQuery(true);
        $query->select('cat_id')
            ->from('#__iproperty_propmid')
            ->where('amen_id = 0')
            ->where('prop_id = '.(int)$id);
        
        $db->setQuery($query);
        $result = $db->loadResultArray();
        
        return $result;
    }

    function getCatIcon($cat, $width = '', $admin = false, $text_only = false)
    {
        $db = JFactory::getDbo();
        
        $query = $db->getQuery(true);
        $query->select('id, icon, title, alias')
            ->from('#__iproperty_categories')
            ->where('id = '.(int)$cat);
        
        $db->setQuery($query, 0, 1);
        $result = $db->loadObject();
        
        if($text_only){
            $caticon = $result->title;
        }else if($result->icon && $admin){
            $caticon = '<img src="'.JURI::root(true).'/media/com_iproperty/categories/'.$result->icon.'" alt="'.$result->title.'" width="'.$width.'" class="hasTip" title="'.$result->title.'" style="margin-right: 2px;" />';
        }else if($result->icon && $result->icon != "nopic.png"){
            $caticon = '<img src="'.JURI::root(true).'/media/com_iproperty/categories/'.$result->icon.'" alt="'.$result->title.'" width="'.$width.'" class="hasTip" title="'.$result->title.'" style="margin-right: 2px;" />';
        }else{
            $caticon = $result->title;
        }
        
        if(!$admin){
            $catlink = ipropertyHelperRoute::getCatRoute($result->id.':'.$result->alias);
            $caticon = '<a href="'.$catlink.'">'.$caticon.'</a>';
        }
        return $caticon;
    }

    function stype_select_list($tag, $attrib = '', $sel = '', $show_available = false, $listonly = false)
    {
        $db         = JFactory::getDbo();
        $stypes     = array();
        $stypes[]   = JHTML::_('select.option', '', JText::_( 'COM_IPROPERTY_SALE_TYPE' ), "value", "text" );
        
        $query = $db->getQuery(true);
        $query->select('DISTINCT(s.id), s.id AS value, s.name AS text')
            ->from('#__iproperty_stypes as s')
            ->where('s.state = 1');
        if($show_available){
            $query->join('INNER','#__iproperty AS p ON p.stype = s.id');
        }
        $query->order('s.name ASC');
        
        $db->setQuery($query);
        $result = $db->loadObjectList();

        foreach($result as $r){
            $stypes[] = JHTML::_('select.option', $r->value, JText::_($r->text), "value", "text" );
        }

        if($listonly){
            return $stypes;
        }else{
            return JHTML::_('select.genericlist', $stypes, $tag, $attrib, "value", "text", $sel );
        }
    }

    function get_stype($stype)
    {
        $db = JFactory::getDbo();
        
        $query = $db->getQuery(true);
        $query->select('name')
            ->from('#__iproperty_stypes')
            ->where('id = '.(int)$stype);
        
        $db->setQuery($query, 0, 1);
        $result = $db->loadResult();
        
        return JText::_($result);
    }

    function get_stypes()
    {
        $db = JFactory::getDbo();
        
        $query = $db->getQuery(true);
        $query->select('id, name')
            ->from('#__iproperty_stypes');

        $db->setQuery($query);
        $result = $db->loadObjectList();
        
        $stypes = array();
        foreach ($result as $r){
            $stypes[$r->id] = $r->name;
        }
        return $stypes;
    }

    function beds_select_list($tag, $attrib = '', $sel = '', $listonly = false)
    {
        $settings = ipropertyAdmin::config();
        $lowbeds = $settings->adv_beds_low;
        $highbeds = $settings->adv_beds_high;

        $rooms = array();
        $rooms[] = JHTML::_('select.option', '', JText::_( 'COM_IPROPERTY_MIN_BEDS' ) );
        for($i = $lowbeds; $i <= $highbeds; $i++){
            $rooms[] = JHTML::_('select.option', $i, $i );
        }

        if($listonly){
            return $rooms;
        }else{
            return JHTML::_('select.genericlist', $rooms, $tag, $attrib, 'value', 'text', $sel );
        }
    }

    function baths_select_list($tag, $attrib = '', $sel = '', $fractions = 1, $listonly = false)
    {
        $settings   = ipropertyAdmin::config();
        $lowbaths   = $settings->adv_baths_low;
        $highbaths  = $settings->adv_baths_high;

        $rooms      = array();
        $rooms[]    = JHTML::_('select.option', '', JText::_( 'COM_IPROPERTY_MIN_BATHS' ) );
        for($i = $lowbaths; $i <= $highbaths; $i++){
            $rooms[] = JHTML::_('select.option', $i, $i );
            if($fractions == 1 && $i != $highbaths){
                $rooms[] = JHTML::_('select.option', $i.'.5', $i.'.5' );
                $rooms[] = JHTML::_('select.option', $i.'.75', $i.'.75' );
            }
        }

        if($listonly){
            return $rooms;
        }else{
            return JHTML::_('select.genericlist', $rooms, $tag, $attrib, 'value', 'text', $sel );
        }
    }

    function country_select_list($tag, $attrib, $sel = null, $show_available = false, $listonly = false)
    {
        $db             = JFactory::getDbo();
        $countries      = array();
        $countries[]    = JHTML::_('select.option', '', JText::_( 'COM_IPROPERTY_COUNTRY' ), "value", "text" );
        
        $query = $db->getQuery(true);
        $query->select('DISTINCT(c.id), c.id AS value, c.title AS text')
            ->from('#__iproperty_countries as c');
        if($show_available){
            $query->join('INNER','#__iproperty AS p ON p.country = c.id');
        }
        $query->order('c.title ASC');
        
        $db->setQuery($query);
        $result = $db->loadObjectList();

        foreach($result as $r){
            $countries[] = JHTML::_('select.option', $r->value, JText::_($r->text), "value", "text" );
        }

        if($listonly){
            return $countries;
        }else{
            return JHTML::_('select.genericlist', $countries, $tag, $attrib, "value", "text", $sel );
        }
    }

    function state_select_list($tag, $attrib, $sel = null, $show_available = false, $listonly = false)
    {
        $db         = JFactory::getDbo();
        $states     = array();
        $states[]   = JHTML::_('select.option', '', JText::_( 'COM_IPROPERTY_STATE' ), "value", "text" );
        
        $query = $db->getQuery(true);
        $query->select('DISTINCT(s.id), s.id AS value, s.title AS text')
            ->from('#__iproperty_states as s');
        if($show_available){
            $query->join('INNER','#__iproperty AS p ON p.locstate = s.id');
        }
        $query->order('s.title ASC');
        
        $db->setQuery($query);
        $result = $db->loadObjectList();

        foreach($result as $r){
            $states[] = JHTML::_('select.option', $r->value, JText::_($r->text), "value", "text" );
        }

        if($listonly){
            return $states;
        }else{
            return JHTML::_('select.genericlist', $states, $tag, $attrib, "value", "text", $sel );
        }
    }

    function city_select_list($tag, $attrib, $sel = null, $listonly = false, $state = false)
    {
        $db         = JFactory::getDbo();
        $cities     = array();
        $cities[]   = JHTML::_('select.option', '', JText::_( 'COM_IPROPERTY_CITY' ), "value", "text" );
        
        $query = $db->getQuery(true);
        $query->select('DISTINCT(city) AS value, city AS text')
            ->from('#__iproperty')
            ->where('state = 1')
            ->where('city != ""');
        if($state){
            $query->where('locstate = '.(int)$state);
        }
        $query->order('city ASC');
        
        $db->setQuery($query);
        $result = $db->loadObjectList();

        foreach($result as $r){
            $cities[] = JHTML::_('select.option', $r->value, JText::_($r->text), "value", "text" );
        }

        if($listonly){
            return $cities;
        }else{
            return JHTML::_('select.genericlist', $cities, $tag, $attrib, "value", "text", $sel );
        }
    }

    function region_select_list($tag, $attrib, $sel = null, $listonly = false)
    {
        $db         = JFactory::getDbo();
        $regions    = array();
        $regions[]  = JHTML::_('select.option', '', JText::_( 'COM_IPROPERTY_REGION' ), "value", "text" );
        
        $query = $db->getQuery(true);
        $query->select('DISTINCT(region) AS value, region AS text')
            ->from('#__iproperty')
            ->where('state = 1')
            ->where('region != ""')
            ->order('region ASC');
        
        $db->setQuery($query);
        $result = $db->loadObjectList();

        foreach($result as $r){
            $regions[] = JHTML::_('select.option', $r->value, JText::_($r->text), "value", "text" );
        }

        if($listonly){
            return $regions;
        }else{
            return JHTML::_('select.genericlist', $regions, $tag, $attrib, "value", "text", $sel );
        }
    }

    function county_select_list($tag, $attrib, $sel = null, $listonly = false)
    {
        $db         = JFactory::getDbo();
        $counties   = array();
        $counties[] = JHTML::_('select.option', '', JText::_( 'COM_IPROPERTY_COUNTY' ), "value", "text" );
        
        $query = $db->getQuery(true);
        $query->select('DISTINCT(county) AS value, county AS text')
            ->from('#__iproperty')
            ->where('state = 1')
            ->where('county != ""')
            ->order('county ASC');
        
        $db->setQuery($query);
        $result = $db->loadObjectList();

        foreach($result as $r){
            $counties[] = JHTML::_('select.option', $r->value, JText::_($r->text), "value", "text" );
        }

        if($listonly){
            return $counties;
        }else{
            return JHTML::_('select.genericlist', $counties, $tag, $attrib, "value", "text", $sel );
        }
    }

    function province_select_list($tag, $attrib, $sel = null, $listonly = false)
    {
        $db         = JFactory::getDbo();
        $provs      = array();
        $provs[]    = JHTML::_('select.option', '', JText::_( 'COM_IPROPERTY_PROVINCE' ), "value", "text" );
        
        $query = $db->getQuery(true);
        $query->select('DISTINCT(province) AS value, province AS text')
            ->from('#__iproperty')
            ->where('state = 1')
            ->where('province != ""')
            ->order('province ASC');
        
        $db->setQuery($query);
        $result = $db->loadObjectList();

        foreach($result as $r){
            $provs[] = JHTML::_('select.option', $r->value, JText::_($r->text), "value", "text" );
        }

        if($listonly){
            return $provs;
        }else{
            return JHTML::_('select.genericlist', $provs, $tag, $attrib, "value", "text", $sel );
        }
    }

    function currencySelectList( $tag, $attrib, $sel = 'USD', $listonly = false )
    {
        $db = JFactory::getDbo();
        
        $query = $db->getQuery(true);
        $query->select('DISTINCT(curr_abbreviation) AS value, CONCAT( TRIM(currency), " - ", curr_abbreviation ) AS text')
            ->from('#__iproperty_currency')
            ->order('currency ASC');        
        
        $db->setQuery($query);
        $result = $db->loadObjectList();

        if($listonly){
            return $result;
        }else{
            return  JHTML::_('select.genericlist', $result, $tag, $attrib, "value", "text", $sel);
        }
    }

    function price_select_list($tag, $attrib, $sel = null, $listonly = false, $do_high = false)
    {
        $settings   = ipropertyAdmin::config();
        $high       = $settings->adv_price_high;
        $low        = $settings->adv_price_low;
        $steps      = 10; // you can edit this to make more or fewer steps
        $increment  = ($high - $low) / $steps;

        $i = 0;
        $t_price = $low;
        $temp_price = '';

        $prices = array();
        if ($do_high){
            $prices[] = JHTML::_('select.option', '', JText::_( 'COM_IPROPERTY_MAX_PRICE' ), "value", "text" );
        } else {
            $prices[] = JHTML::_('select.option', '', JText::_( 'COM_IPROPERTY_MIN_PRICE' ), "value", "text" );
        }

        while ($i <= $steps) {
            if ($i == 0 && $settings->adv_nolimit && !$do_high ) {
                $temp_value = '';
                $temp_price = ipropertyHTML::getFormattedPrice(0, '', true);
            } else if ($i == $steps && $settings->adv_nolimit && $do_high) {
                $temp_value = '';
                $temp_price = ipropertyHTML::getFormattedPrice($high, '', true) . '+';
            } else {
                $temp_value = $t_price;
                $temp_price = ipropertyHTML::getFormattedPrice($t_price, '', true);
            }
            $prices[]   =  JHTML::_('select.option', $temp_value, $temp_price, "value", "text" );
            $t_price    = $t_price + $increment;
            $i++;
        }

        if($listonly){
            return $prices;
        }else{
            return  JHTML::_('select.genericlist', $prices, $tag, $attrib, "value", "text", $sel);
        }
    }

    /*function Docs( $name, &$active, $javascript = null, $directory = null )
    {
        jimport( 'joomla.filesystem.folder' );

        if ( !$directory ) {
            $directory = '/images/iproperty';
        }

        $docFiles = JFolder::files( JPATH_SITE . $directory );
        $docs   = array( JHTML::_('select.option','', JText::_( 'COM_IPROPERTY_SELECT' ) ) );
        foreach ( $docFiles as $file ) {
            if ( eregi( "pdf|doc|odt|docx", $file ) ) {
                $docs[] = JHTML::_('select.option',$file );
            }
        }
        $docs = JHTML::_('select.genericlist', $docs, $name, 'class="inputbox" size="1" '. $javascript, 'value', 'text', $active );

        return $docs;
    }*/

    function checkbox( $name, $tag_attribs, $value, $text = '', $showtext = 0, $checked = null ) 
    {
        $t = ($showtext == '1') ? "&nbsp;".$text : '';
        $checked = ($checked == 1) ? " checked=\"checked\"" : '';
        return "<input type=\"checkbox\" name=\"".$name."\" ".$tag_attribs." value=\"".$value."\"".$checked." />".$t;
    }

    function agentSelectList($tag, $attrib, $selected = null, $listonly = false, $useauth = false )
    {
        $db         = JFactory::getDBO();
        $agents     = array();
        $agents[]   = JHTML::_('select.option', '', JText::_( 'COM_IPROPERTY_AGENT' ), "value", "text" );
        
        $query = $db->getQuery(true);
        $query->select('id AS value, CONCAT_WS(",", lname, fname) AS text')
            ->from('`#__iproperty_agents`')
            ->where('state = 1');
        if($useauth){
            $ipauth = new ipropertyHelperAuth();
            if (!$ipauth->getAdmin()) {
                switch ($ipauth->getAuthLevel()){
                    case 1: //company level
                        $query->where('company = '.(int)$ipauth->getUagentCid());
                    break;
                    case 2: //agent level
                        $query->where('company = '.(int)$ipauth->getUagentCid());
                        // if not a super agent, only show all company agents if its the multiselect list
                        if (!$ipauth->getSuper()) $query->where('id = '.(int)$ipauth->getUagentId());
                    break;
                }
            }
        }
        $query->order('lname ASC');
        
        $db->setQuery( $query );
        $agents = array_merge( $agents, $db->loadObjectList() );

        if( $selected ){
            $selected = explode(',',$selected);
        }

        if($listonly){
            return $agents;
        }else{
            return  JHTML::_('select.genericlist', $agents, $tag, $attrib, "value", "text", $selected);
        }
    }

    function multicatSelectList($tag, $attrib, $sel = null, $listonly = false)
    {
        $db         = JFactory::getDbo();
        $cats       = array();
        $cats[]     = JHTML::_('select.option', '', JText::_( 'COM_IPROPERTY_CATEGORY' ) ,"value","text");
        
        $cats   = array_merge($cats, ipropertyHTML::multisubcatSelect(0, ""));        
        $sel    = explode(',', $sel);

        if($listonly){
            return $cats;
        }else{
            return  JHTML::_('select.genericlist', $cats, $tag, $attrib, "value", "text", $sel);
        }
    }

    function multisubcatSelect($parent, $prefix)
    {
        $db         = JFactory::getDbo();
        $options    = array();
        
        $query      = ipropertyHelperQuery::getCategories($parent);
        $db->setQuery($query);
        
        $result     = $db->loadObjectList();
        $total      = count($result);

        for($i = 0; $i < ($total-1); $i++){
            $options[]  = JHTML::_('select.option', $result[$i]->id,$prefix."- ".$result[$i]->title, "value", "text");
            $options    = array_merge($options, ipropertyHTML::multisubcatSelect($result[$i]->id, $prefix."- "));
        }

        if($total > 0){
            $options[]  = JHTML::_('select.option', $result[$total-1]->id, $prefix."- ".$result[$total-1]->title, "value", "text");
            $options    = array_merge($options, ipropertyHTML::multisubcatSelect($result[$total-1]->id, $prefix."- "));
        }

        return $options;
    }

    function getAgentName($agent_id)
    {
        $db = JFactory::getDbo();
        
        $query = $db->getQuery(true);
        $query->select('id, fname, lname')
            ->from('#__iproperty_agents')
            ->where('id = '.(int)$agent_id);
        
        $db->setQuery($query, 0, 1);
        $result = $db->loadObject();
        return $result->fname.' '.$result->lname;
    }

    function getAgentEmail($agent_id) 
    {
        $db = JFactory::getDbo();
        
        $query = $db->getQuery(true);
        $query->select('email')
            ->from('#__iproperty_agents')
            ->where('id = '.(int)$agent_id);
        
        $db->setQuery($query, 0, 1);
        $result = $db->loadResult();
        return $result;
    }

    function amen_select_list( $tag, $attrib, $sel = null ) 
    {
        $db = JFactory::getDbo();
        
        $query = $db->getQuery(true);
        $query->select('id AS value, title AS text')
            ->from('#__iproperty_amenities');
        
        $db->setQuery($query);
        $amens = $db->loadObjectList();
        
        $sel = explode(',', $sel);
        return JHTML::_('select.genericlist', $amens, $tag, $attrib, "value", "text", $sel);
    }

    function companySelectList($tag, $attrib, $sel = null, $listonly = false, $useauth = false)
    {
        $db         = JFactory::getDbo();        

        $companies = array();
        $companies[] = JHTML::_('select.option', '', JText::_( 'COM_IPROPERTY_COMPANY' ), "value", "text" );

        $query = $db->getQuery(true);
        $query->select('id AS value, name AS text')
            ->from('`#__iproperty_companies`')
            ->where('state = 1');
        if($useauth){
            $ipauth = new ipropertyHelperAuth();
            if (!$ipauth->getAdmin()) {
                switch ($ipauth->getAuthLevel()){
                    case 1: //company level
                    case 2: //agent level
                        $query->where('id = '.(int)$ipauth->getUagentCid());
                    break;
                }
            }
        }
        $query->order('name ASC');
        
        $db->setQuery( $query );
        $companies = array_merge( $companies, $db->loadObjectList() );

        if($listonly){
            return $companies;
        }else{
            return  JHTML::_('select.genericlist', $companies, $tag, $attrib, "value", "text", $sel);
        }
    }

    function amenCheckboxList( $tag, $attrib, $sel = array(), $cat = '' ) 
    {
        $db = JFactory::getDbo();
        
        $query = $db->getQuery(true);
        $query->select('id AS value, title AS text')
            ->from('#__iproperty_amenities');
        if($cat){
            $query->where('cat = '.(int)$cat);
        }
        $query->order('title ASC');
        
        $db->setQuery($query);
        $amen_array = $db->loadObjectList();
        
        return ipropertyHTML::checkBoxList($amen_array, $tag, $attrib, $sel);
    }

    function typesCheckboxList( $tag, $attrib, $sel = array() ) 
    {
        $db = JFactory::getDbo();
        
        $query = $db->getQuery(true);
        $query->select('id AS value, title AS text')
            ->from('#__iproperty_categories')
            ->where('state = 1')
            ->order('title ASC');

        $db->setQuery($query);
        $types_array = $db->loadObjectList();
        
        return ipropertyHTML::checkBoxList($types_array, $tag, $attrib, $sel);
    }   

    function checkBoxList( &$arr, $tag_name, $tag_attribs, $selected = null, $key = 'value', $text = 'text' ) 
    {
       $html = "
       <table class=\"ptable\" id=\"checkBoxContainer\">
           \n\t<tr>";
           $colcount = 0;
           for ($i=0, $n=count( $arr ); $i < $n; $i++ ) {
              $k = $arr[$i]->$key;
              $t = $arr[$i]->$text;
              $id = @$arr[$i]->id;

              $extra = '';
              $extra .= $id ? " id=\"" . $arr[$i]->id . "\"" : '';
              if (is_array( $selected )) {
                 foreach ($selected as $obj) {
                    $k2 = $obj;
                    if ($k == $k2) {
                       $extra .= " checked=\"checked\" ";
                       break;
                    }
                 }
              } else {
                 $extra .= ($k == $selected ? " checked=\"checked\" " : '');
              }
              $html .= "\n\t<td valign='top' width='25%'><input type=\"checkbox\" name=\"$tag_name\" value=\"".$k."\"$extra $tag_attribs />&nbsp;&nbsp;" . $t . "</td>";

              $colcount++;
              if( $colcount == 4 ){
                $colcount = 0;
                $html .= "\n</tr>\n<tr>";
              }
           }
       $html .= "\n</tr>
       \n</table>";
       return $html;
    }

    function getAvailableAgents( $id = null, $order = 'lname ASC', $limit = 999999 )
    {
        $db = JFactory::getDbo();
        
        $query = $db->getQuery(true);
        $query->select('a.*, CONCAT(fname, " ", lname) AS agent_name, c.id AS companyid, c.name AS companyname, c.alias as co_alias')
            ->from('#__iproperty_agents AS a')
            ->leftJoin('#__iproperty_companies AS c ON c.id = a.company')
            ->leftJoin('#__iproperty_agentmid AS am ON am.agent_id = a.id')
            ->where('am.prop_id = '.(int)$id)
            ->where('a.state = 1')
            ->order($order);
        
        $db->setQuery($query, 0, $limit);
        $result = $db->loadObjectList();
        
        return $result;
    }
    
    function getPropertyAmens($id)
    {
        $db = JFactory::getDbo();
        
        $query = $db->getQuery(true);
        $query->select('a.*')
            ->from('#__iproperty_amenities AS a')
            ->leftJoin('#__iproperty_propmid AS pm ON pm.amen_id = a.id')
            ->where('pm.prop_id = '.(int)$id);

        $db->setQuery($query);
        $amens = $db->loadObjectList();
        
        return $amens;
    }

    function notifyAdmin($id )
    {
        $app  = JFactory::getApplication();

        $admin_from    = $app->getCfg('fromname');
        $admin_email   = $app->getCfg('mailfrom');

        $user          = JFactory::getUser();
        $userid        = $user->get('id');
        $username      = $user->get('name');
        $useremail     = $user->get('email');
        $settings      = ipropertyAdmin::config();
        //$uri           =JURI::getInstance();
        $property_path  = JURI::base().ipropertyHelperRoute::getPropertyRoute($id);
        $fulldate       = JHTML::_('date','now',JText::_('DATE_FORMAT_LC2'));

        $text = '<style>
                    body{ font-family: arial; font-size: 12px; }
                    .result{color: ' . $settings->accent_color . ';}
                </style>';


        $where          = array();
        $where[]        = 'p.id = '.$id;
        $notification   = $app->getCfg('fromname') .' '. JText::_( 'COM_IPROPERTY_SAVED_PROPERTY_NOTIFICATION' );
        $property       = new IpropertyHelperProperty($this->_db);
        $property->setType('property');
        $property->setWhere( $where );
        $property       = $property->getProperty(0,1);
        $property       = $property[0];

        $property_full_address = $property->street_address.'<br />'
                                .$property->city.', '.ipropertyHTML::getstatename($property->locstate).$property->province.' '.$property->postcode.'<br />'
                                .ipropertyHTML::getcountryname($property->country);

        $text .= '<p>' . $username . ' (' . $useremail . ') '.JText::_( 'COM_IPROPERTY_SAVED_PROPERTY_NOTIFY_TEXT' ).'</p>';
        $text .= '---------------------------------------------------------<br />';
        $text .= JText::_( 'COM_IPROPERTY_USER' ).'<br />';
        $text .= '---------------------------------------------------------<br />';
        $text .= '<p><strong>'.JText::_( 'COM_IPROPERTY_USER_ID' ).':</strong> <span class="result">' . $userid . '</span><br />';
        $text .= '<strong>'.JText::_( 'COM_IPROPERTY_USER_NAME' ).':</strong> <span class="result">' . $username . '</span><br />';
        $text .= '<strong>'.JText::_( 'COM_IPROPERTY_USER_EMAIL' ).':</strong> <span class="result">' . $useremail . '</span><br /></p>';

        $text .= '---------------------------------------------------------<br />';
        $text .= JText::_( 'COM_IPROPERTY_PROPERTY' ).'<br />';
        $text .= '---------------------------------------------------------<br />';

        $text .= '<p><strong>'.JText::_( 'COM_IPROPERTY_PROP_ID' ).':</strong> <span class="result">' . $property->mls_id . '</span><br />';
        $text .= '<strong>'.JText::_( 'COM_IPROPERTY_ADDRESS' ).':</strong><br /><span class="result">' . $property_full_address . '</span><br />';
        $text .= '<strong>'.JText::_( 'COM_IPROPERTY_PRICE' ).':</strong> <span class="result">' . $property->formattedprice . '</span><br />';
        $text .= '</p>';

        $text .= '<p>' . JText::_( 'COM_IPROPERTY_FOLLOW_LINK' ) . ':<br />
                     <a href="' . $property_path . '">' . $property_path . '</a><br /><br />
                     <span style="font-size: 10px; color: #999;">' . JText::_( 'COM_IPROPERTY_GENERATED_BY_INTELLECTUAL_PROPERTY' ) . ' ' . $fulldate . '.
                  </p>';


        if( $admin_email && $settings->notify_saveprop == 1 ){
            $mail = JFactory::getMailer();
            $mail->addRecipient( $admin_email );
            $mail->setSender( array( $admin_email, $admin_from ) );
            $mail->setSubject( $notification );
            $mail->setBody( $text );
            $mail->isHTML(true);
            $mail->Send();
        }
    }

    function isNew($created, $days = 7)
    {
        $stamp = strtotime("-$days days");
        $created = strtotime($created);
        $new = ( $created >= $stamp ) ? true : false;
        return $new;
    }

    function getThumbnail($prop_id, $link = '', $alt = '', $width = 200, $imgattributes = '', $linkattributes = '', $suffix = true, $tags = true, $rel_path = true)
    {
        $db             = JFactory::getDbo();
        $settings       = ipropertyAdmin::config();
        
        $query = $db->getQuery(true);
        $query->select('path, type, fname, remote')
            ->from('#__iproperty_images')
            ->where('propid = '.(int)$prop_id)
            ->where('( type = ".jpg" OR type = ".jpeg" OR type = ".gif" OR type = ".png")')
            ->order('ordering ASC');

        $db->setQuery($query, 0, 1);
        $thumb         = $db->loadObject();
        $imgsuffix     = ($suffix) ? '_thumb' : '';
        $root_path     = ($rel_path) ? JURI::root(true) : substr(JURI::root(), 0, -1);

        //add appropriate path to thumbnail file
        if ( $thumb ) {
            $path      = ($thumb->remote == 1) ? $thumb->path : $root_path.$settings->imgpath;
            $thumbnail = ($thumb->remote == 1) ? $path.$thumb->fname.$thumb->type : $path.$thumb->fname.$imgsuffix.$thumb->type;
        } else { //no filename found - return nopic img
            $path      = $root_path.$settings->imgpath;
            $thumbnail = $path.'nopic.png';
        }

        if($tags){
            //create thumbnail image with link if applicable
            $thumbimg = '';
            if($link) $thumbimg .= '<a href="'.$link.'" '.$linkattributes.'>';
            $thumbimg .= '<img src="'.$thumbnail.'" alt="'.$alt.'" width="'.$width.'" '.$imgattributes.'/>';
            if($link) $thumbimg .= '</a>';
            return $thumbimg;
        } else {
            return $thumbnail;
        }
    }

    function getFormattedPrice($price='', $stype_freq='', $advsearch = false, $call = false, $price2 = false, $newline = false)
    {
        if($call == true){ //call for price flag
            $formattedprice = JText::_( 'COM_IPROPERTY_CALL_FOR_PRICE' );
        }else if($price != 0 || $advsearch == true){ //if valid price & not using advanced search
            $settings  = ipropertyAdmin::config();

            $nformat            = $settings->nformat;
            $currency_digits    = $settings->currency_digits;
            $currency           = $settings->currency;
            $currency_pos       = $settings->currency_pos;

            if($stype_freq == '') $currency_digits = 0;
            $before_curr    = ($currency_pos == 0) ? $currency : ''; //currency before price
            $after_curr     = ($currency_pos == 1) ? ' '.$currency : ''; //currency after price

            $payments       = ($stype_freq) ? '/'.$stype_freq : '';
            $format         = ($nformat == 1) ? number_format($price, $currency_digits) : number_format($price,  $currency_digits, ',', '.');
            $formattedprice = $before_curr.$format.$after_curr.$payments;

            if($price2 && $price2 != '0.00'){
                $p2format           = ($nformat == 1) ? number_format($price2, $currency_digits) : number_format($price2,  $currency_digits, ',', '.');
                $oldprice           = '<span class="ip_slashprice" style="text-decoration: line-through;">'.$before_curr.$p2format.$after_curr.'</span>';
                $oldprice           .= ($newline) ? '<br />' : ' ';
                $formattedprice     = $oldprice.'<span class="ip_newprice">'.$formattedprice.'</span>';
            }
        }else{ //there was no price set
            $formattedprice = JText::_( 'COM_IPROPERTY_CALL_FOR_PRICE' );
        }
        return $formattedprice;
    }

    function displayBanners($stype = '', $new = '', $path = '', $settings = '', $updated = '')
    {
        if($settings->banner_display == 1){ //image banners
            $banner_display = '';
            if( $new == 1 && $settings->new_days ){
                $banner_display .= '
                    <div class="property_overview_bannerbotleft">
                        <img src="'.$path.'/components/com_iproperty/assets/images/banners/banner_new.png" alt="'.JText::_( 'COM_IPROPERTY_NEW' ).'" title="'.JText::_( 'COM_IPROPERTY_NEW' ).'" />
                    </div>';
            }else if( $updated == 1 && $settings->updated_days ){
                $banner_display .= '
                    <div class="property_overview_bannerbotleft">
                        <img src="'.$path.'/components/com_iproperty/assets/images/banners/banner_updated.png" alt="'.JText::_( 'COM_IPROPERTY_UPDATED' ).'" title="'.JText::_( 'COM_IPROPERTY_UPDATED' ).'" />
                    </div>';
            }
            // dynamic sale type banners v1.5.5
            $banner_display .= ipropertyHTML::displayStypeBanner($stype, 1, $path);
        }else if($settings->banner_display == 2){ //css banners
            $banner_display = '';
            if( $new == 1 && $settings->new_days ){
                $banner_display .= '
                    <div class="property_overview_bannercsstop bannernew">
                        '.JText::_( 'COM_IPROPERTY_NEW' ).'
                    </div>';
            }else if( $updated == 1 && $settings->updated_days ){
                $banner_display .= '
                    <div class="property_overview_bannercsstop bannerupdated">
                        '.JText::_( 'COM_IPROPERTY_UPDATED' ).'
                    </div>';
            }
            // dynamic sale type banners v1.5.5
            $banner_display .= ipropertyHTML::displayStypeBanner($stype, 2);
        }else{ //no banners
            $banner_display = '';
        }
        return $banner_display;
    }

    function displayStypeBanner($stype, $type, $path = null)
    {
        // load stype object from db
        jimport('joomla.filesystem.file');
        $db = JFactory::getDbo();
        
        $query = $db->getQuery(true);
        $query->select('*')
                ->from('#__iproperty_stypes')
                ->where('id = '.(int)$stype);
        
        $db->setQuery($query, 0, 1);
        $result = $db->loadObject();

        $stype_banner = '';
        if($result->show_banner && $result->state){
            // banner image
            if($type == 1 && $result->banner_image){
                $stype_banner = '<div class="property_overview_bannerright"><img src="'.$path.'/'.$result->banner_image.'" alt="'.JText::_($result->name).'" /></div>';
            }elseif($type == 2 && $result->banner_color){
                $stype_banner = '<div class="property_overview_bannercssbot" style="background: '.$result->banner_color.'; font-weight: bold; color: #fff;">'.JText::_($result->name).'</div>';
            }
        }
        return $stype_banner;
    }

    function getStreetAddress($settings, $title = null, $street_num = null, $street = null, $street2 = null, $apt = null, $hide = null)
    {
        $street_address = '';
        if($settings->showtitle && $title){
            $street_address = $title;
        }else{
            if($hide){
                $street_address = JText::_( 'COM_IPROPERTY_ADDRESS_HIDDEN' );
            }else{
                if(!$settings->street_num_pos){ //street number before street
                    $street_address .= $street_num.' '.$street;
                    $street_address .= ($street2) ? ' '.$street2 : '';
                    $street_address .= ($apt) ? ' '.$apt : '';
                }else{ //street number after street
                    $street_address .= $street;
                    $street_address .= ($street2) ? ' '.$street2 : '';
                    $street_address .= ($street_num) ? ' '.$street_num : '';
                    $street_address .= ($apt) ? ' '.$apt : '';
                }
            }
        }
        return $street_address;
    }

    function getFullAddress($street = null, $city = null, $locstate = null, $province = null, $zip = null, $country = null)
    {
        $fulladdress = '';
        $fulladdress .= ($street) ? '<span>'.$street.'</span><br />' : '';
        $fulladdress .= ($city) ? $city : '';
        $fulladdress .= ($locstate) ? ', '.ipropertyHTML::getstatename($locstate) : '';
        $fulladdress .= ($province) ? ', '.$province : '';
        $fulladdress .= ($zip) ? ' '.$zip : '';
        $fulladdress .= ($country) ? '<br />'.ipropertyHTML::getcountryname($country) : '';
        return $fulladdress;
    }

    function getCatName($catid)
    {
        $db   = JFactory::getDbo();
        
        $query = $db->getQuery(true);
        $query->select('id, title')
                ->from('#__iproperty_categories')
                ->where('id = '.(int)$catid);

        $db->setQuery($query, 0, 1);
        $result     = $db->loadObject();
        return $result->title;
    }

    function getPropertyTitle($prop_id)
    {
        $db         = JFactory::getDbo();
        $settings   = ipropertyAdmin::config();
        
        $query = $db->getQuery(true);
        $query->select('id, street_num, street, street2, title')
                ->from('#__iproperty')
                ->where('id = '.(int)$prop_id);
                
        $db->setQuery($query, 0, 1);

        if($p = $db->loadObject()){
            $prop_title = '';
            if($settings->showtitle && $p->title){
                $prop_title = $p->title;
            }else{
                if(!$settings->street_num_pos){ //street number before street
                    $prop_title = $p->street_num.' '.$p->street.' '.$p->street2;
                }else{ //street number after street
                    $prop_title = $p->street.' '.$p->street2.' '.$p->street_num;
                }
            }
            return $prop_title;
        }else{
            return JText::_( 'COM_IPROPERTY_PROPERTY_NOT_FOUND' );
        }
    }

    function propertySelectList($tag, $attrib, $sel = null, $listonly = false, $useauth = false)
    {
        $db         = JFactory::getDbo();
        $user       = JFactory::getUser();
        $groups     = $user->getAuthorisedViewLevels();
        
        // Filter by start and end dates.
        $nullDate   = $db->Quote($db->getNullDate());
        $date       = JFactory::getDate();
        $nowDate    = $db->Quote($date->toSql());
        
        $properties = array();
        $properties[] = JHTML::_('select.option', '', JText::_( 'COM_IPROPERTY_PROPERTY' ), "value", "text" );
        
        $query = $db->getQuery(true);
        $query->select('id AS value, CONCAT(street_num, " ", street, ", ", city, " - ", mls_id) AS text')
            ->from('`#__iproperty`');        
        if($useauth){ 
            $ipauth = new ipropertyHelperAuth();
            if (!$ipauth->getAdmin()) {
                switch ($ipauth->getAuthLevel()){
                    case 1: //company level
                        $query->where('listing_office = '.(int)$ipauth->getUagentCid());
                    break;
                    case 2: //agent level
                        $query->where('listing_office = '.(int)$ipauth->getUagentCid());
                        if (!$ipauth->getSuper()) $query->where('id IN ( SELECT prop_id FROM #__iproperty_agentmid WHERE agent_id = '.(int)$ipauth->getUagentId().' )');
                    break;
                }
            }
        }        
        (is_array($groups) && !empty($groups)) ? $query->where('access IN ('.implode(",", $groups).')') : '';
        $query->where('state = 1')
            ->where('(publish_up = '.$nullDate.' OR publish_up <= '.$nowDate.')')
            ->where('(publish_down = '.$nullDate.' OR publish_down >= '.$nowDate.')')
            ->order('street_num, street ASC');

        $db->setQuery($query);
        $properties = array_merge( $properties, $db->loadObjectList() );

        if($listonly){
            return $properties;
        }else{
            return  JHTML::_('select.genericlist', $properties, $tag, $attrib, "value", "text", $sel);
        }
    }

    function getOpenHouses($prop_id)
    {
        $db     = JFactory::getDBO();
        
        // Filter by start and end dates.
        $nullDate   = $db->Quote($db->getNullDate());
        $date       = JFactory::getDate();
        $nowDate    = $db->Quote($date->toSql());
        
        $query = $db->getQuery(true);
        $query->select('id, name, openhouse_start AS startdate, openhouse_end AS enddate, comments AS comments')
                ->from('#__iproperty_openhouses')
                ->where('prop_id = '.(int)$prop_id)
                ->where('state = 1')
                ->where('openhouse_end >= '.$nowDate)
                ->order('openhouse_start DESC');
        
        $db->setQuery($query);
        return $db->loadObjectList();
    }

    #as of 1.6.1 used in advsearch
    function getCategories($parent = null, $order = 'ordering ASC')
    {
        $user = JFactory::getUser();
        $db = JFactory::getDbo();

        $groups = $user->getAuthorisedViewLevels();

        // Filter by start and end dates.
        $nullDate   = $db->Quote($db->getNullDate());
        $date       = JFactory::getDate();
        $nowDate    = $db->Quote($date->toSql());
        
        $query = $db->getQuery(true);
        $query->select('id AS value, title AS text')
                ->from('#__iproperty_categories')
                ->where('(publish_up = '.$nullDate.' OR publish_up <= '.$nowDate.')')
                ->where('(publish_down = '.$nullDate.' OR publish_down >= '.$nowDate.')')
                ->where('state = 1');
        if(is_array($groups) && !empty($groups)){
            $query->where('access IN ('.implode(",", $groups).')');
        }
        if(is_numeric($parent)){
            $query->where('parent = '.(int)$parent);
        }
        $query->order($order);
        
        $db->setQuery($query);
        return $db->loadObjectList();
    }
    
    function getCategory($catid)
    {
        $user = JFactory::getUser();
        $db = JFactory::getDbo();
        
        $groups = $user->getAuthorisedViewLevels();

        // Filter by start and end dates.
        $nullDate   = $db->Quote($db->getNullDate());
        $date       = JFactory::getDate();
        $nowDate    = $db->Quote($date->toSql());
        
        $query = $db->getQuery(true);
        $query->select('id, alias')
                ->from('#__iproperty_categories')
                ->where('id = '.(int)$catid)
                ->where('(publish_up = '.$nullDate.' OR publish_up <= '.$nowDate.')')
                ->where('(publish_down = '.$nullDate.' OR publish_down >= '.$nowDate.')')
                ->where('state = 1');
        if(is_array($groups) && !empty($groups)){
            $query->where('access IN ('.implode(",", $groups).')');
        }
        
        $db->setQuery($query, 0, 1);
        if($result = $db->loadObject()){
            return $result;
        }else{
            return false;
        }
    }
    
    /*
     *
     * under development 1.5.5
     *
     * function typesCheckboxList( $tag, $attrib, $selected = array() ) {

        $database = JFactory::getDBO();
        $query = ipropertyHelperQuery::getCategories(0);
        $database->setQuery($query);
        $maincats = $database->loadObjectList();

        $html = "
            <table class=\"ptable\" id=\"checkBoxContainer\">
            \n<tr>";
            $colcount = 0;
            foreach($maincats as $m){
                $html .= '<td width="25%" valign="top">';
                $extra = '';
                if (is_array( $selected )) {
                 foreach ($selected as $obj) {
                    $k2 = $obj;
                    if ($m->id == $k2) {
                       $extra .= " checked=\"checked\" ";
                       break;
                    }
                 }
                } else {
                 $extra .= ($m->id == $selected ? " checked=\"checked\" " : '');
                }
                $html .= '<div class="ip_adv_maincat"><input type="checkbox" name="'.$tag.'" value="'.$m->id.'" '.$attrib.$extra.' /> '.$m->title.'</div>';
                $query = ipropertyHelperQuery::getCategories($m->id);
                $database->setQuery($query);
                $subcats = $database->loadObjectList();
                if(count($subcats)){
                    foreach($subcats as $s){
                        $extra = '';
                        if (is_array( $selected )) {
                         foreach ($selected as $obj) {
                            $k2 = $obj;
                            if ($s->id == $k2) {
                               $extra .= " checked=\"checked\" ";
                               break;
                            }
                         }
                        } else {
                         $extra .= ($s->id == $selected ? " checked=\"checked\" " : '');
                        }
                        $html .= '<div class="ip_adv_subcat"><input type="checkbox" name="'.$tag.'" value="'.$s->id.'"'.$extra.$attrib.' /> '.$s->title.'</div>';
                    }
                }
                $html .= '</td>';
                $colcount++;
                if( $colcount == 4 ){
                    $colcount = 0;
                    $html .= "\n</tr>\n<tr>";
                }
            }
        $html .= "\n</tr>
        \n</table>";
        return $html;
    }
     *
     *
     */

    /*function buildPtypeOptions($parent, $prefix, $indent = "&nbsp;&nbsp;&nbsp;"){
        $database = JFactory::getDBO();

        $options=array();
        $q = ipropertyHelperQuery::getCategories($parent);

        $database->setQuery($q);
        $result = $database->loadObjectList();
        $total  = count($result);

        for($i = 0; $i < $total-1; $i++){
            $options[] = array('id'=>$result[$i]->id, 'value'=>$result[$i]->title.'main', 'prefix'=>$prefix, 'parent'=>$parent);
            $options   = array_merge($options,ipropertyHTML::buildPtypeOptions($result[$i]->id, $prefix.$indent, $indent));
        }

        if($total > 0){
            $options[] = array('id'=>$result[$total-1]->id, 'value'=>$result[$total-1]->title.'sub', 'prefix'=>$prefix, 'parent'=>$parent);
            $options   = array_merge($options,ipropertyHTML::buildPtypeOptions($result[$total-1]->id, $prefix.$indent, $indent));
        }

        return $options;
    }*/
}