<?php
/**
 * @version		$Id: router.php 21389 2011-05-26 17:28:26Z dextercowley $
 * @package		Joomla.Site
 * @subpackage	com_banners
 * @copyright	Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

function IPropertyBuildRoute( &$query )
{
    // if this is an edit form view, forget about routing - it's already in the correct view
    if(isset($query['view']) && in_array($query['view'], array('agentform','companyform','propform'))) return;
    
    $segments	= array();

	// get a menu item based on Itemid or currently active
	$app		= JFactory::getApplication();
	$menu		= $app->getMenu();

	// we need a menu item.  Either the one specified in the query, or the current active one if none specified
	if (empty($query['Itemid'])) {
		$menuItem = $menu->getActive();
		$menuItemGiven = false;
	}
	else {
		$menuItem = $menu->getItem($query['Itemid']);
		$menuItemGiven = true;
	}
    
    if(isset($query['view']))
    {
        $segments[] = $query['view'];
        unset( $query['view'] );
    }
    if (isset($query['layout'])) {
        $segments[] = $query['layout'];
        unset( $query['layout'] );
	}
    if(isset($query['id']))
    {
        $segments[] = $query['id'];
        unset( $query['id'] );
    }
	
    return $segments;
}

function IPropertyParseRoute( $segments )
{    
    $vars = array();
    
    // if this is an item being edited or saved, return just the id
    if(is_numeric($segments[0])){
        $vars['id'] = $segments[0];
        return $vars;
    }
        
    switch($segments[0])
    {
        case 'advsearch':
            $vars['view'] = 'advsearch';
        break;
        case 'agentform':
            $vars['view'] = 'agentform';
            $vars['layout'] = $segments[1];
            $id = explode( ':', $segments[2] );
            $vars['id'] = (int) $id[0];
        break;
        case 'agentproperties':
            $vars['view'] = 'agentproperties';
            $id = explode( ':', $segments[1] );
            $vars['id'] = (int) $id[0];
        break;
        case 'agents':
            $vars['view'] = 'agents';
        break;
        case 'allproperties':
            $vars['view'] = 'allproperties';
        break;
        case 'cat':
            $vars['view'] = 'cat';
            $id = explode( ':', $segments[1] );
            $vars['id'] = (int) $id[0];
        break;
        case 'companies':
            $vars['view'] = 'companies';
        break;
        case 'companyagents':
            $vars['view'] = 'companyagents';
            $id = explode( ':', $segments[1] );
            $vars['id'] = (int) $id[0];
        break;
        case 'companyform':
            $vars['view'] = 'companyform';
            $vars['layout'] = $segments[1];
            $id = explode( ':', $segments[2] );
            $vars['id'] = (int) $id[0];
        break;
        case 'companyproperties':
            $vars['view'] = 'companyproperties';
            $id = explode( ':', $segments[1] );
            $vars['id'] = (int) $id[0];
        break;
        case 'contact':
            $vars['view'] = 'contact';
            $vars['layout'] = $segments[1];
            $id = explode( ':', $segments[2] );
            $vars['id'] = (int) $id[0];
        break;
        case 'feed':
            $vars['view'] = 'feed';
        break;
        case 'home':
            $vars['view'] = 'home';
        break;
        case 'ipuser':
            $vars['view'] = 'ipuser';
        break;
        case 'manage':
            $vars['view'] = 'manage';
        break;
        case 'openhouses':
            $vars['view'] = 'openhouses';
        break;
        case 'property':
            $vars['view'] = 'property';
            $id = explode( ':', $segments[1] );
            $vars['id'] = (int) $id[0];
        break;
        case 'propform':
            $vars['view'] = 'propform';
            $vars['layout'] = $segments[1];
            $id = explode( ':', $segments[2] );
            $vars['id'] = (int) $id[0];
        break;
    }
    return $vars;
}
