<?php
/**
 * @version 2.0 2012-01-20
 * @package Joomla
 * @subpackage Intellectual Property
 * @copyright (C) 2012 the StarTech
 * @license GNU/GPL see LICENSE.php
 */

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.view');

class IpropertyViewProperty extends JView
{
    function display($tpl = null)
    {
        $app  = JFactory::getApplication();
        $option     = JRequest::getCmd('option');

        //jimport('joomla.html.pane');
        JHTML::_('behavior.modal');
        JHTML::_('behavior.tooltip');
        JHtml::_('behavior.formvalidation');

        JPluginHelper::importPlugin( 'iproperty' );
        $dispatcher = JDispatcher::getInstance();

        if(JRequest::getBool('print') == 1) JRequest::setVar('tmpl', 'component');

        $this->ipbaseurl    = JURI::root(true);
        $this->ipauth       = new ipropertyHelperAuth();
        $document           = JFactory::getDocument();
        $settings           = ipropertyAdmin::config();
        $session            = JFactory::getSession();
        $user               = JFactory::getUser();

        $document->addStyleSheet($this->ipbaseurl.'/components/com_iproperty/assets/css/'.$settings->css_file);
        $document->addScript($this->ipbaseurl.'/components/com_iproperty/assets/js/ipcommon.js');

        // Check if login is required to view details - if so check user and display form if not logged in
        if($settings->require_login){
            if(!$user->get('id')){
                $this->_displayLogin('login');
                return;
            }
        }

        if(JRequest::getVar('usersave')) $tpl = 'usersave';
        if(JRequest::getVar('calculator')) $tpl = 'calculator';

        $model          = $this->getModel();
        $property       = $this->get('data');
        $docs           = $this->get('docs');
        $images         = $this->get('images');
        $amenities      = $this->get('amenities');
        $layout         = $this->getLayout();

        if(!empty($property)){
            $property       = $property[0];
        }else{
            $property       = '';
        }

        if(!$property){
            $this->_displayNoResult('noresult');
            return;
        }

        if($layout == 'gallery'){
            $this->_displayGallery($property, $images);
            return;
        }

        //check if gmaps enabled and property has lat and long values
        if( $settings->googlemap_enable == 1 && $property->lat_pos && $property->long_pos ) {
            $this->gmap_OK = 1;
        }else{
            $this->gmap_OK = false;
        }

        //create toolbar
        $dispatcher->trigger( 'onBeforeRenderToolbar', array( &$settings ) );
        $extra = array();
        //$extra['accent'] = substr($settings->accent,-6);
        $extra['property'] = $property;
        //$extra['propprice'] = $property->price;
        //$extra['propertyname'] = $property->street_address;
        echo ipropertyHTML::buildToolbar('property', $extra);

        // trigger onBeforeRenderProperty plugins
        $dispatcher->trigger( 'onBeforeRenderProperty', array( &$property, &$settings ) );

        // trigger phocapdf plugin if exists - under development 2012 vk
        jimport('joomla.filesystem.file');
        if(JPluginHelper::isEnabled('phocapdf', 'iproperty') && JFile::exists(JPATH_ROOT.DS.'plugins'.DS.'phocapdf'.DS.'iproperty'.DS.'iproperty'.DS.'ipropertyhelper.php')){
           require_once(JPATH_ROOT.DS.'plugins'.DS.'phocapdf'.DS.'iproperty'.DS.'iproperty'.DS.'ipropertyhelper.php');
           PhocaPDFIpropertyHelper::renderPDFIcon();
        }

        $lists = array();
        $lists['copyme']    = ipropertyHTML::checkbox( 'copy_me', '', 1, JText::_( 'COM_IPROPERTY_COPY_ME_EMAIL' ), 1, $session->get('ip_sender_copy_me'));

        //contact preferences
        $prefs      = array();
        $prefs[]    = JHTML::_('select.option', JText::_( 'COM_IPROPERTY_PHONE' ), JText::_( 'COM_IPROPERTY_PHONE' ) );
        $prefs[]    = JHTML::_('select.option', JText::_( 'COM_IPROPERTY_EMAIL' ), JText::_( 'COM_IPROPERTY_EMAIL' ) );
        $prefs[]    = JHTML::_('select.option', JText::_( 'COM_IPROPERTY_EITHER' ), JText::_( 'COM_IPROPERTY_EITHER' ) );
        $lists['preference'] = JHTML::_('select.radiolist', $prefs, 'sender_preference', 'size="5" class="inputbox"', 'value', 'text', $session->get('ip_sender_preference'));

        //contact preferences
        $ctime      = array();
        $ctime[]    = JHTML::_('select.option', JText::_( 'COM_IPROPERTY_MORNING' ), JText::_( 'COM_IPROPERTY_MORNING' ) );
        $ctime[]    = JHTML::_('select.option', JText::_( 'COM_IPROPERTY_AFTERNOON' ), JText::_( 'COM_IPROPERTY_AFTERNOON' ) );
        $ctime[]    = JHTML::_('select.option', JText::_( 'COM_IPROPERTY_NIGHT' ), JText::_( 'COM_IPROPERTY_NIGHT' ) );
        $lists['contact_time'] = JHTML::_('select.radiolist', $ctime, 'sender_ctime', 'size="5" class="inputbox"', 'value', 'text', $session->get('ip_sender_ctime'));

        $accent_color           = ( $settings->accent ) ? $settings->accent : '#d2e4ea';
        $secondary_accent       = ( $settings->secondary_accent ) ? $settings->secondary_accent : '#deeaff';
        $tab_height             = ( $settings->tab_height ) ? $settings->tab_height : '275'; // was 220
        $tab_width              = ( $settings->tab_width ) ? $settings->tab_width : '450'; // was 350
        $picfolder              = $this->ipbaseurl.$settings->imgpath;
        $agentfolder            = $this->ipbaseurl.'/media/com_iproperty/agents/';
        $agent_photo_width      = ( $settings->agent_photo_width ) ? $settings->agent_photo_width : '90';
        $galleryheight          = ( $settings->gallery_height ) ? $settings->gallery_height : '400';
        $gallerywidth           = ( $settings->gallery_width ) ? $settings->gallery_width : '700';

        if($images){
            switch($settings->gallerytype){
                case 1:
                case 2:
                default: // Default or Noobslide
                    $gallery_link           = JRoute::_(ipropertyHelperRoute::getPropertyRoute($property->id).'&layout=gallery');
                    $gallery_attributes     = ' class="modal"  rel="{handler: \'iframe\', size: {x: '. ($settings->gallery_width + 50) .', y: '. ($settings->gallery_height + 75) .'}}"';
                    break;
                case 3: // Slimbox
                    $path                   = ($images[0]->remote == 1) ? $images[0]->path : $picfolder;
                    $ip_imgtitle            = ($images[0]->title) ? $images[0]->title : $property->street_address;
                    $ip_imgdesc             = ($images[0]->description) ? $images[0]->description : $property->city.' '.ipropertyHTML::getStateName($property->locstate).$property->province;
                    $gallery_link           = $path.$images[0]->fname.$images[0]->type;
                    $gallery_attributes     = ' rel="lightbox-ipgallery" title="'.$ip_imgtitle.': '.$ip_imgdesc.'"';
                    $gallery_attributes2    = ' rel="lightbox-ipgallery2" title="'.$ip_imgtitle.': '.$ip_imgdesc.'"';

                    $document->addStyleSheet($this->ipbaseurl.'/components/com_iproperty/assets/galleries/slimbox/css/slimbox.css');
                    $document->addScript($this->ipbaseurl.'/components/com_iproperty/assets/galleries/slimbox/js/slimbox_1.2.js');
                    break;
                case 4: // Slideshow2
                    $gallery_link           = '#';
                    //slideshow script
                    $document->addScript(JURI::root(true).'/components/com_iproperty/assets/galleries/slideshow2/js/slideshow.js');
                    $document->addStyleSheet(JURI::root(true).'/components/com_iproperty/assets/galleries/slideshow2/css/slideshow.css');

                    $transType = 'none';
                    // depending on which transition type selected, load proper script
                    $sstype = '';
                    switch ($transType){
                        case 'none':
                        default:
                            //no special effects
                        break;
                        case 'flash':
                            $document->addScript(JURI::root(true).'/components/com_iproperty/assets/galleries/slideshow2/js/slideshow.flash.js');
                            $sstype = ".Flash";
                        break;
                        case 'kenburns':
                            $document->addScript(JURI::root(true).'/components/com_iproperty/assets/galleries/slideshow2/js/slideshow.kenburns.js');
                            $sstype = ".KenBurns";
                        break;
                        case 'push':
                            $document->addScript(JURI::root(true).'/components/com_iproperty/assets/galleries/slideshow2/js/slideshow.push.js');
                            $sstype = ".Push";
                        break;
                        case 'fold':
                            $document->addScript(JURI::root(true).'/components/com_iproperty/assets/galleries/slideshow2/js/slideshow.fold.js');
                            $sstype = ".Fold";
                        break;
                    }

                    $remote     = $images[0]->remote ? true : false; // set this if we're using remote images

                    $imgPush    = "window.addEvent('domready', function() {\n";
                    $imgPush   .= "    var ip_slideshowimgs = {"."\r\n";

                    $i = 0;

                    foreach($images as $img) {
                        // new img object format for the new slideshow script:
                        // var data = {'1.jpg': { caption: 'Caption', href: 'link.html' }, etc.};
                        $path                   = ($img->remote == 1) ? $img->path : $picfolder;
                        $ip_imgtitle            = ($img->title) ? $img->title : $property->street_address;
                        $ip_imgdesc             = ($img->description) ? $img->description : $property->city.' '.ipropertyHTML::getStateName($property->locstate).$property->province;
                        $ip_imgloc              = $path.$img->fname.$img->type;

                        if(!strpos($ip_imgloc, 'nopic.png')){
                            $imgPush .= "       '".addslashes($ip_imgloc)."':{ ";
                            $imgPush .= "caption: '".addslashes($ip_imgtitle).' - '.addslashes(trim($ip_imgdesc))."', href: '".addslashes($ip_imgloc)."'";
                            $imgPush .= "}";
                        }
                        $i++;
                        if($i != count($images)){
                            $imgPush .= ","."\r\n";
                        }else{
                            $imgPush .= "\r\n";
                        }
                    }

                    $imgPush    .= "    };"."\r\n";

                    $imgPush    .= "    var ip_slideshow = new Slideshow".$sstype."( 'ip_imagetab', ip_slideshowimgs, {"."\r\n";
                    // options array
                    $imgPush    .= "        width: $tab_width,"."\r\n"
                                .  "        height: $tab_height,"."\r\n"
                                .  "        delay: 3000,"."\r\n"
                                .  "        duration: 1800,"."\r\n"
                                .  "        controller: true,"."\r\n"
                                .  "        loop: true,"."\r\n"
                                .  "        thumbnails: false,"."\r\n";
                    //$imgPush    .= !$remote ? "        thumbnails: true,"."\r\n"."      replace:[/(\.[^\.]+)$/, '_thumb$1'],"."\r\n" : '';
                    $imgPush    .= "        captions: true"."\r\n"
                                .  "    });"."\r\n";

                    $imgPush .= "   });"."\r\n";

                    $document->addScriptDeclaration($imgPush);
                    break;
            }
        }

        $this->assignRef('p', $property);
        $this->assignRef('images', $images);
        $this->assignRef('amenities', $amenities);
        $this->assignRef('docs', $docs);
        $this->assignRef('agent', $agent);
        $this->assignRef('settings', $settings);
        $this->assignRef('lists', $lists);
        $this->assignRef('additionals', $additionals);
        $this->assignRef('accent_color', $accent_color);
        $this->assignRef('secondary_accent', $secondary_accent);
        $this->assignRef('tab_width', $tab_width);
        $this->assignRef('tab_height', $tab_height);
        $this->assignRef('folder', $picfolder);
        $this->assignRef('agent_folder', $agentfolder);
        $this->assignRef('agent_photo_width', $agent_photo_width);
        $this->assignRef('galleryheight', $galleryheight);
        $this->assignRef('gallerywidth', $gallerywidth);
        $this->assignRef('gallery_link', $gallery_link);
        $this->assignRef('gallery_attributes', $gallery_attributes);
        $this->assignRef('gallery_attributes2', $gallery_attributes2);
        $this->assignRef('dispatcher', $dispatcher);
        $this->assignRef('return', $return);
        $this->assignRef('session', $session);
        $this->assignRef('user', $user);

        $this->extras_array = array( "beds"         => JText::_( 'COM_IPROPERTY_BEDS' ),
                                     "baths"        => JText::_( 'COM_IPROPERTY_BATHS' ),
                                     "sqft"         => (!$settings->measurement_units) ? JText::_( 'COM_IPROPERTY_SQFT' ) : JText::_( 'COM_IPROPERTY_SQM' ),
                                     "lotsize"      => JText::_( 'COM_IPROPERTY_LOT_SIZE' ),
                                     "lot_acres"    => JText::_( 'COM_IPROPERTY_LOT_ACRES' ),
                                     "yearbuilt"    => JText::_( 'COM_IPROPERTY_YEAR_BUILT' ),
                                     "heat"         => JText::_( 'COM_IPROPERTY_HEAT' ),
                                     "garage_type"  => JText::_( 'COM_IPROPERTY_GARAGE_TYPE' ),
                                     "roof"         => JText::_( 'COM_IPROPERTY_ROOF' ));

        if( $this->gmap_OK == 1 ){
            //if max zoom is higher than 13, set the default to a medium level 13 zoom.
            //if max zoom is less than 13, set to the maximum zoom level allowable
            $default_zoom   = ($settings->max_zoom > 13) ? 13 : $settings->max_zoom;
            $max_zoom       = $settings->max_zoom ? $settings->max_zoom : 21;

            // check for template map icons
            $templatepath       = $app->getTemplate();
            $map_house_icon     = '/components/com_iproperty/assets/images/map/icon56.png';
            if(JFile::exists('templates'.DS.$templatepath.DS.'images'.DS.'iproperty'.DS.'map'.DS.'icon56.png')) $map_house_icon = '/templates/'.$templatepath.'/images/iproperty/map/icon56.png';

            // check if Google Places API is enabled
            if( JPluginHelper::isEnabled('iproperty', 'googleplaces') ){
                // load the places library
                $document->addScript('http://maps.google.com/maps/api/js?libraries=places&sensor=false');
            } else {
                $document->addScript('http://maps.google.com/maps/api/js?sensor=false');
            }

            $gscript = '
            var map;

            window.addEvent("domready", function(){
                var zoom = '.$default_zoom.';
                var ipbaseurl = "' . JURI::root(true) . '";
                var coord = new google.maps.LatLng(' . $property->lat_pos . ', ' . $property->long_pos . ');
                var icon_url = ipbaseurl+"'.$map_house_icon.'";
                var streetview = new google.maps.StreetViewService();

                var mapoptions = {
                                    zoom: zoom,
                                    center: coord,
                                    //draggable: false,
                                    mapTypeControl: true,
                                    navigationControl: true,
                                    streetViewControl: false,
                                    mapTypeId: google.maps.MapTypeId.ROADMAP,
                                    maxZoom: '.$max_zoom.'
                                }

                map = new google.maps.Map($("map_canvas"), mapoptions);

                var marker  = new google.maps.Marker({
                    position: coord,
                    visible: true,
                    flat: true,
                    clickable: false,
                    map: map,
                    icon: icon_url
                });

                $$(".map_panel").addEvent("click", function(e){
                    setTimeout(function() {
                        google.maps.event.trigger(map, "resize");
                        map.setZoom( map.getZoom() );
                        map.setCenter(coord);
                    }, (10));
                });';

            if(JPluginHelper::isEnabled('iproperty', 'streetviewtab')) {
                $gscript .= '
                    var panoramaElement = $("pano");
                        streetview.getPanoramaByLocation(coord, 25, function(data, status){
                            switch(status){
                                case google.maps.StreetViewStatus.OK:
                                    $$(".ipstreetview").addEvent("click", function(e){
                                        setTimeout(function() {
                                            var panorama = new google.maps.StreetViewPanorama(panoramaElement, {
                                                position: coord
                                            });
                                            google.maps.event.trigger(panorama, "resize");
                                        }, (10));
                                    });
                                    break;
                                case google.maps.StreetViewStatus.ZERO_RESULTS:
                                    $$(".ipstreetview").setStyle("display", "none");
                                    break;
                                default:
                                    $$(".ipstreetview").setStyle("display", "none");
                            }
                        }); ';
            }

            $gscript .= '
            });';
            $document->addScriptDeclaration( $gscript );
        }

        $property_js = '
            function formValidate(f) {
               if (document.formvalidator.isValid(f)) {
                  return true;
               }
               else {
                  alert("' . JText::_( 'COM_IPROPERTY_ENTER_REQUIRED' ) . '");
               }
               return false;
            }

            window.addEvent("domready", function(){
                var saveSlide = ($("save-panel")) ? new Fx.Slide("save-panel").hide() : null;
                if(saveSlide){
                    $("saveslidein").addEvent("click", function(e){
                        $("save-panel").setStyle("display", "block");
                        if($("calculate-panel")) $("calculate-panel").setStyle("display", "block");
                        e = new Event(e);
                        (calcSlide) ? calcSlide.slideOut() : "";
                        (saveSlide.open) ? saveSlide.slideOut() : saveSlide.slideIn();
                        e.stop();
                    });
                }

                var calcSlide = ($("calculate-panel")) ? new Fx.Slide("calculate-panel").hide() : null;
                if(calcSlide){
                    $("calcslidein").addEvent("click", function(e){
                        $("calculate-panel").setStyle("display", "block");
                        if($("save-panel")) $("save-panel").setStyle("display", "block");
                        e = new Event(e);
                        (saveSlide) ? saveSlide.slideOut() : "";
                        (calcSlide.open) ? calcSlide.slideOut() : calcSlide.slideIn();
                        e.stop();
                    });
                }
            });';
        $document->addScriptDeclaration( $property_js );

        // add custom style if no template iproperty.css is found
        $templatepath        = $app->getTemplate();
        if(!JFile::exists('templates'.DS.$templatepath.DS.'css'.DS.'iproperty.css')){
            $property_styles = '
                .ip_container{border-color: '.$this->accent_color.';}
                div.current{ border-top: 1px solid '. $this->accent_color . ' !important; padding: 0px; }
                dl.tabs dt.open{ background: ' . $this->secondary_accent . ' !important; border-bottom: 1px solid ' . $this->secondary_accent . ' !important; color: ' . $this->accent_color . ' !important;  }
                dl.tabs dt{ border: 1px solid '. $this->accent_color . ' !important; background: ' . $this->accent_color . ' !important; border-width: 1px 1px 0px 1px; }';
            $document->addStyleDeclaration( $property_styles );
        }

        $this->_prepareDocument($property);

        parent::display($tpl);
    }

    protected function _prepareDocument($property)
    {
        $app            = JFactory::getApplication();
        $menus          = $app->getMenu();
        $pathway        = $app->getPathway();
        $this->params   = $app->getParams();
        $title          = null;

        $menu = $menus->getActive();
        if ($menu) {
            $this->params->def('page_heading', $this->params->get('page_title', $menu->title));
        } else {
            $this->params->def('page_heading', JText::_( 'COM_IPROPERTY_INTELLECTUAL_PROPERTY' ));
        }

        $title = ($property) ? $property->street_address : JText::_( 'COM_IPROPERTY_INTELLECTUAL_PROPERTY' );
        $this->iptitle = $title;
        if (empty($title)) {
            $title = $app->getCfg('sitename');
        }
        elseif ($app->getCfg('sitename_pagetitles', 0) == 1) {
            $title = JText::sprintf('JPAGETITLE', $app->getCfg('sitename'), $title);
        }
        elseif ($app->getCfg('sitename_pagetitles', 0) == 2) {
            $title = JText::sprintf('JPAGETITLE', $title, $app->getCfg('sitename'));
        }
        $this->document->setTitle($title);

        // Set meta data according to menu params
        if ($property->metadesc != '') {
            $this->document->setDescription($property->metadesc);
        } else if (!$property->metadesc && $this->params->get('menu-meta_description')) {
            $this->document->setDescription($this->params->get('menu-meta_description'));
        }

        if ($property->metakey != '') {
            $this->document->setMetadata('keywords', $property->metakey);
        } else if (!$property->metakey && $this->params->get('menu-meta_keywords')) {
            $this->document->setMetadata('keywords', $this->params->get('menu-meta_keywords'));
        }
        if ($this->params->get('robots')) $this->document->setMetadata('robots', $this->params->get('robots'));

        // Breadcrumbs
        if(is_object($menu) && $menu->query['view'] != 'property') {
            $pathway->addItem($title);
        }
    }

    function _displayNoResult($tpl = null)
    {
        $app  = JFactory::getApplication();
        $option     = JRequest::getCmd('option');

        $document       = JFactory::getDocument();
        $settings       = ipropertyAdmin::config();
        $accent_color   = ( $settings->accent ) ? $settings->accent : '#d2e4ea';

        $document->setTitle( JText::_( 'COM_IPROPERTY_PROPERTY_NOT_FOUND' ) );
        $this->assignRef('accent_color', $accent_color);

        parent::display($tpl);
    }

    function _displayGallery($property = null, $images = null)
    {
        $app  = JFactory::getApplication();
        $option     = JRequest::getCmd('option');

        JRequest::setVar('tmpl', 'component');
        $this->ipbaseurl    = JURI::root(true);
        $document           = JFactory::getDocument();
        $settings           = ipropertyAdmin::config();

        $picfolder          = $this->ipbaseurl.$settings->imgpath;
        $galleryheight      = ( $settings->gallery_height ) ? $settings->gallery_height : '400';
        $gallerywidth       = ( $settings->gallery_width ) ? $settings->gallery_width : '700';
        $accent_color       = $settings->accent;
        $secondary_accent   = $settings->secondary_accent;

        $styles = '
                #viewer_img{height: '. $galleryheight . 'px;width: ' . $gallerywidth . 'px;overflow:hidden; border: solid 1px '. $accent_color.';}
                .gallery_info, div#box5_buttons{width: ' . $gallerywidth . 'px; border-color: '.$accent_color.';}
                .mask2{height: '. $galleryheight . 'px;width: ' . $gallerywidth . 'px;}
                #box5{width: ' . $gallerywidth . 'px;}
                #box5 span{width: ' . $gallerywidth . 'px;}';

        $document->addStyleSheet($this->ipbaseurl.'/components/com_iproperty/assets/css/'.$settings->css_file);
        $document->addStyleDeclaration($styles);

        switch($settings->gallerytype)
        {
            case 1:
                $document->addScript($this->ipbaseurl.'/components/com_iproperty/assets/galleries/viewer/gallery.js');
                $gallery_js ='
                    window.addEvent(\'domready\',function(){
                        pic = new Array();' . "\n\t";
                        $x=1;
                        foreach($images as $i) {
                            $path = ($i->remote == 1) ? $i->path : $picfolder;
                            $gallery_js .= 'pic['.$x.'] = new IPImage("'.$path.'","'.addslashes($i->img_title).'","'.addslashes($i->img_description).'","'.addslashes($i->fname).'","'.$i->type.'");' . "\n\t";
                            $x++;
                        }
                        $gallery_js .= 'gl = new IPGallery(1,'. count($images) .');' . "\n\t";
                        $gallery_js .= 'gl.showPic(1);' . "\n";

                $gallery_js .= '
                        });';

                $document->addScriptDeclaration( $gallery_js );
            break;
            case 2: //NoobSlideshow

                $document->addScript($this->ipbaseurl.'/components/com_iproperty/assets/galleries/noobslide/_class.noobSlide.js');
                $img_array = array();
                for( $i = 0; $i < (count( $images )); $i++ ){
                $img_array[] = $i;
                }
                $noobScript = '
                window.addEvent(\'domready\',function(){
                    //SAMPLE 5 (mode: vertical, using "onWalk" )
                    var info5 = $(\'info5\').setOpacity(0.5);
                    var imageItems = [';
                        $imgcnt = 0;
                        foreach($images as $i){
                            $imgtitle = ($i->title) ? addslashes($i->title) : addslashes(preg_replace('/\s+/', ' ', trim($property->street_address)));
                            $imgdesc  = ($i->description) ? addslashes($i->description) : addslashes($property->city.' '.ipropertyHTML::getStateName($property->locstate).$property->province);
                            $noobScript .= '{title:\''.$imgtitle.'\', desc:\''.$imgdesc.'\'}';
                            $imgcnt++;
                            if($imgcnt < count($images)){
                                $noobScript .= ",\n\t";
                            }
                        }
                $noobScript .= '];
                    var hs5 = new noobSlide({
                        box: $(\'box5\'),
                        size: ' . $gallerywidth . ',
                        items: imageItems,
                        autoPlay: true,
                        interval: 6000,
                        fxOptions: {
                            duration: 800,
                            transition: Fx.Transitions.Expo.easeInOut,
                            wait: false
                        },
                        addButtons: {
                            previous: $(\'prev5\'),
                            play: $(\'play5\'),
                            stop: $(\'stop5\'),
                            next: $(\'next5\')
                        },
                        onWalk: function(currentItem){
                            $(\'imgtitle\').empty();
                            $(\'imgdesc\').empty();
                            $(\'imgtitle\').innerHTML = currentItem.title;
                            $(\'imgdesc\').innerHTML = currentItem.desc;
                        }
                    });
                });';
                $document->addScriptDeclaration( $noobScript );
            break;
            case 3:
                //another gallery
            break;
        }

        $this->assignRef('images', $images);
        $this->assignRef('folder', $picfolder);
        $this->assignRef('gallerywidth', $gallerywidth);
        $this->assignRef('accent_color', $accent_color);
        $this->assignRef('secondary_accent', $secondary_accent);
        $this->assignRef('p', $property);
        $this->assignRef('settings', $settings);

        parent::display();
    }

    function _displayLogin($tpl = null)
    {
        $document               = JFactory::getDocument();
        $settings               = ipropertyAdmin::config();
        $accent_color           = ( $settings->accent ) ? $settings->accent : '#d2e4ea';
        $usersConfig            = JComponentHelper::getParams( 'com_users' );
        $return                 = base64_encode(JRoute::_(ipropertyHelperRoute::getPropertyRoute(JRequest::getInt('id')), false));

        $document->setTitle( JText::_( 'COM_IPROPERTY_PLEASE_LOG_IN' ) );

        $this->assignRef('return', $return);
        $this->assignRef('allowreg', $usersConfig->get( 'allowUserRegistration' ));
        $this->assignRef('settings', $settings);
        $this->assignRef('accent_color', $accent_color);

        parent::display($tpl);
    }
}

?>
